#![allow(clippy::module_inception)]
#![allow(clippy::upper_case_acronyms)]
#![allow(clippy::large_enum_variant)]
#![allow(clippy::wrong_self_convention)]
#![allow(clippy::should_implement_trait)]
#![allow(clippy::blacklisted_name)]
#![allow(clippy::vec_init_then_push)]
//! <p>The AWS Cost and Usage Report API enables you to programmatically create, query, and delete
//! AWS Cost and Usage report definitions.</p>
//! <p>AWS Cost and Usage reports track the monthly AWS costs and usage
//! associated with your AWS account.
//! The report contains line items for each unique combination of AWS product,
//! usage type, and operation that your AWS account uses.
//! You can configure the AWS Cost and Usage report to show only the data that you want, using the
//! AWS Cost and Usage API.</p>
//! <p>Service Endpoint</p>
//! <p>The AWS Cost and Usage Report API provides the following endpoint:</p>
//! <ul>
//! <li>
//! <p>cur.us-east-1.amazonaws.com</p>
//! </li>
//! </ul>

// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
pub use error_meta::Error;

pub use config::Config;

mod aws_endpoint;
#[cfg(feature = "client")]
pub mod client;
pub mod config;
pub mod error;
mod error_meta;
pub mod input;
mod json_deser;
mod json_errors;
mod json_ser;
pub mod model;
mod no_credentials;
pub mod operation;
mod operation_deser;
mod operation_ser;
pub mod output;
pub static PKG_VERSION: &str = env!("CARGO_PKG_VERSION");
pub use smithy_http::byte_stream::ByteStream;
pub use smithy_http::result::SdkError;
pub use smithy_types::Blob;
static API_METADATA: aws_http::user_agent::ApiMetadata =
    aws_http::user_agent::ApiMetadata::new("costandusagereportservice", PKG_VERSION);
pub use aws_types::region::Region;
pub use aws_types::Credentials;
#[cfg(feature = "client")]
pub use client::Client;
pub use smithy_http::endpoint::Endpoint;
