// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
/// <p>A  tag is a key-value pair where the key and value are case-sensitive.            
/// You can use tags to categorize and track all your ElastiCache resources, with the exception of global replication group. When you add or remove tags on replication groups, those actions will be replicated to all nodes in the replication group.
/// For more information, see <a href="http://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/IAM.ResourceLevelPermissions.html">Resource-level permissions</a>.</p>
/// <p>
/// For example, you can use cost-allocation tags to your ElastiCache resources,
/// Amazon generates a cost allocation report as a comma-separated value (CSV) file
/// with your usage and costs aggregated by your tags.
/// You can apply tags that represent business categories (such as cost centers, application names, or owners)
/// to organize your costs across multiple services.</p>
/// <p>For more information,
/// see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/Tagging.html">Using Cost Allocation Tags in Amazon ElastiCache</a>
/// in the <i>ElastiCache User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AddTagsToResource {
    _private: (),
}
impl AddTagsToResource {
    /// Creates a new builder-style object to manufacture [`AddTagsToResourceInput`](crate::input::AddTagsToResourceInput)
    pub fn builder() -> crate::input::add_tags_to_resource_input::Builder {
        crate::input::add_tags_to_resource_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AddTagsToResource {
    type Output = std::result::Result<
        crate::output::AddTagsToResourceOutput,
        crate::error::AddTagsToResourceError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_add_tags_to_resource_error(response)
        } else {
            crate::operation_deser::parse_add_tags_to_resource_response(response)
        }
    }
}

/// <p>Allows network ingress to a cache
/// security group. Applications using ElastiCache must be running on Amazon EC2, and Amazon EC2
/// security groups are used as the authorization mechanism.</p>
/// <note>
/// <p>You cannot authorize ingress from an Amazon EC2 security group in one region to an
/// ElastiCache cluster in another region.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AuthorizeCacheSecurityGroupIngress {
    _private: (),
}
impl AuthorizeCacheSecurityGroupIngress {
    /// Creates a new builder-style object to manufacture [`AuthorizeCacheSecurityGroupIngressInput`](crate::input::AuthorizeCacheSecurityGroupIngressInput)
    pub fn builder() -> crate::input::authorize_cache_security_group_ingress_input::Builder {
        crate::input::authorize_cache_security_group_ingress_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AuthorizeCacheSecurityGroupIngress {
    type Output = std::result::Result<
        crate::output::AuthorizeCacheSecurityGroupIngressOutput,
        crate::error::AuthorizeCacheSecurityGroupIngressError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_authorize_cache_security_group_ingress_error(response)
        } else {
            crate::operation_deser::parse_authorize_cache_security_group_ingress_response(response)
        }
    }
}

/// <p>Apply the service update. For more information on service updates and applying them, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/applying-updates.html">Applying Service Updates</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct BatchApplyUpdateAction {
    _private: (),
}
impl BatchApplyUpdateAction {
    /// Creates a new builder-style object to manufacture [`BatchApplyUpdateActionInput`](crate::input::BatchApplyUpdateActionInput)
    pub fn builder() -> crate::input::batch_apply_update_action_input::Builder {
        crate::input::batch_apply_update_action_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for BatchApplyUpdateAction {
    type Output = std::result::Result<
        crate::output::BatchApplyUpdateActionOutput,
        crate::error::BatchApplyUpdateActionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_batch_apply_update_action_error(response)
        } else {
            crate::operation_deser::parse_batch_apply_update_action_response(response)
        }
    }
}

/// <p>Stop the service update. For more information on service updates and stopping them, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/stopping-self-service-updates.html">Stopping Service Updates</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct BatchStopUpdateAction {
    _private: (),
}
impl BatchStopUpdateAction {
    /// Creates a new builder-style object to manufacture [`BatchStopUpdateActionInput`](crate::input::BatchStopUpdateActionInput)
    pub fn builder() -> crate::input::batch_stop_update_action_input::Builder {
        crate::input::batch_stop_update_action_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for BatchStopUpdateAction {
    type Output = std::result::Result<
        crate::output::BatchStopUpdateActionOutput,
        crate::error::BatchStopUpdateActionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_batch_stop_update_action_error(response)
        } else {
            crate::operation_deser::parse_batch_stop_update_action_response(response)
        }
    }
}

/// <p>Complete the migration of data.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CompleteMigration {
    _private: (),
}
impl CompleteMigration {
    /// Creates a new builder-style object to manufacture [`CompleteMigrationInput`](crate::input::CompleteMigrationInput)
    pub fn builder() -> crate::input::complete_migration_input::Builder {
        crate::input::complete_migration_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CompleteMigration {
    type Output = std::result::Result<
        crate::output::CompleteMigrationOutput,
        crate::error::CompleteMigrationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_complete_migration_error(response)
        } else {
            crate::operation_deser::parse_complete_migration_response(response)
        }
    }
}

/// <p>Makes a copy of an existing snapshot.</p>
/// <note>
/// <p>This operation is valid for Redis only.</p>
/// </note>
/// <important>
/// <p>Users or groups that have permissions to use the <code>CopySnapshot</code> operation  
/// can create their own Amazon S3 buckets and copy snapshots to it.
/// To control access to your snapshots, use an IAM policy to control who has the ability to use
/// the <code>CopySnapshot</code> operation.
/// For more information about using IAM to control the use of ElastiCache operations, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/backups-exporting.html">Exporting Snapshots</a>
/// and <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/IAM.html">Authentication & Access Control</a>.</p>
/// </important>
/// <p>You could receive the following error messages.</p>
/// <p class="title">
/// <b>Error Messages</b>
/// </p>
/// <ul>
/// <li>
/// <p>
/// <b>Error Message:</b>
/// The S3 bucket %s is outside of the region.</p>
/// <p>
/// <b>Solution:</b>
/// Create an Amazon S3 bucket in the same region as your snapshot.
/// For more information, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/backups-exporting.html#backups-exporting-create-s3-bucket">Step 1: Create an Amazon S3 Bucket</a> in the ElastiCache User Guide.</p>
/// </li>
/// <li>
/// <p>
/// <b>Error Message:</b>
/// The S3 bucket %s does not exist.</p>
/// <p>
/// <b>Solution:</b>
/// Create an Amazon S3 bucket in the same region as your snapshot.
/// For more information, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/backups-exporting.html#backups-exporting-create-s3-bucket">Step 1: Create an Amazon S3 Bucket</a> in the ElastiCache User Guide.</p>
/// </li>
/// <li>
/// <p>
/// <b>Error Message:</b>
/// The S3 bucket %s is not owned by the authenticated user.</p>
/// <p>
/// <b>Solution:</b>
/// Create an Amazon S3 bucket in the same region as your snapshot.
/// For more information, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/backups-exporting.html#backups-exporting-create-s3-bucket">Step 1: Create an Amazon S3 Bucket</a> in the ElastiCache User Guide.</p>
/// </li>
/// <li>
/// <p>
/// <b>Error Message:</b>
/// The authenticated user does not have sufficient permissions to perform the desired activity.</p>
/// <p>
/// <b>Solution:</b>
/// Contact your system administrator to get the needed permissions.</p>
/// </li>
/// <li>
/// <p>
/// <b>Error Message:</b>
/// The S3 bucket %s already contains an object with key %s.</p>
/// <p>
/// <b>Solution:</b>
/// Give the <code>TargetSnapshotName</code> a new and unique value.
/// If exporting a snapshot,
/// you could alternatively create a new Amazon S3 bucket
/// and use this same value for <code>TargetSnapshotName</code>.</p>
/// </li>
/// <li>
/// <p>
/// <b>Error Message: </b>
/// ElastiCache has not been granted READ permissions %s on the S3 Bucket.</p>
/// <p>
/// <b>Solution:</b>
/// Add List and Read permissions on the bucket.
/// For more information, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/backups-exporting.html#backups-exporting-grant-access">Step 2: Grant ElastiCache Access to Your Amazon S3 Bucket</a> in the ElastiCache User Guide.</p>
/// </li>
/// <li>
/// <p>
/// <b>Error Message: </b>
/// ElastiCache has not been granted WRITE permissions %s on the S3 Bucket.</p>
/// <p>
/// <b>Solution:</b>
/// Add Upload/Delete permissions on the bucket.
/// For more information, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/backups-exporting.html#backups-exporting-grant-access">Step 2: Grant ElastiCache Access to Your Amazon S3 Bucket</a> in the ElastiCache User Guide.</p>
/// </li>
/// <li>
/// <p>
/// <b>Error Message: </b>
/// ElastiCache has not been granted READ_ACP permissions %s on the S3 Bucket.</p>
/// <p>
/// <b>Solution:</b>
/// Add View Permissions on the bucket.
/// For more information, see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/backups-exporting.html#backups-exporting-grant-access">Step 2: Grant ElastiCache Access to Your Amazon S3 Bucket</a> in the ElastiCache User Guide.</p>
/// </li>
/// </ul>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CopySnapshot {
    _private: (),
}
impl CopySnapshot {
    /// Creates a new builder-style object to manufacture [`CopySnapshotInput`](crate::input::CopySnapshotInput)
    pub fn builder() -> crate::input::copy_snapshot_input::Builder {
        crate::input::copy_snapshot_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CopySnapshot {
    type Output =
        std::result::Result<crate::output::CopySnapshotOutput, crate::error::CopySnapshotError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_copy_snapshot_error(response)
        } else {
            crate::operation_deser::parse_copy_snapshot_response(response)
        }
    }
}

/// <p>Creates a cluster. All nodes in the
/// cluster run the same protocol-compliant cache engine software, either Memcached
/// or Redis.</p>
/// <p>This operation is not supported for Redis (cluster mode enabled) clusters.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateCacheCluster {
    _private: (),
}
impl CreateCacheCluster {
    /// Creates a new builder-style object to manufacture [`CreateCacheClusterInput`](crate::input::CreateCacheClusterInput)
    pub fn builder() -> crate::input::create_cache_cluster_input::Builder {
        crate::input::create_cache_cluster_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateCacheCluster {
    type Output = std::result::Result<
        crate::output::CreateCacheClusterOutput,
        crate::error::CreateCacheClusterError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_cache_cluster_error(response)
        } else {
            crate::operation_deser::parse_create_cache_cluster_response(response)
        }
    }
}

/// <p>Creates a new Amazon ElastiCache cache parameter group. An ElastiCache
/// cache parameter group is a collection of parameters and their values that are applied to all of the nodes
/// in any cluster or replication group using the CacheParameterGroup.</p>
/// <p>A newly created CacheParameterGroup is an exact duplicate of the default parameter group
/// for the CacheParameterGroupFamily. To customize the newly created CacheParameterGroup you can
/// change the values of specific parameters. For more information, see:</p>
/// <ul>
/// <li>
/// <p>
/// <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/APIReference/API_ModifyCacheParameterGroup.html">ModifyCacheParameterGroup</a> in the ElastiCache API Reference.</p>
/// </li>
/// <li>
/// <p>
/// <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/ParameterGroups.html">Parameters and Parameter Groups</a> in the ElastiCache User Guide.</p>
/// </li>
/// </ul>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateCacheParameterGroup {
    _private: (),
}
impl CreateCacheParameterGroup {
    /// Creates a new builder-style object to manufacture [`CreateCacheParameterGroupInput`](crate::input::CreateCacheParameterGroupInput)
    pub fn builder() -> crate::input::create_cache_parameter_group_input::Builder {
        crate::input::create_cache_parameter_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateCacheParameterGroup {
    type Output = std::result::Result<
        crate::output::CreateCacheParameterGroupOutput,
        crate::error::CreateCacheParameterGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_cache_parameter_group_error(response)
        } else {
            crate::operation_deser::parse_create_cache_parameter_group_response(response)
        }
    }
}

/// <p>Creates a new cache security group. Use a
/// cache security group to control access to one or more clusters.</p>
/// <p>Cache security groups are only used when you are creating a cluster outside of an Amazon
/// Virtual Private Cloud (Amazon VPC). If you are creating a cluster inside of a VPC, use a cache
/// subnet group instead. For more information,
/// see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/APIReference/API_CreateCacheSubnetGroup.html">CreateCacheSubnetGroup</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateCacheSecurityGroup {
    _private: (),
}
impl CreateCacheSecurityGroup {
    /// Creates a new builder-style object to manufacture [`CreateCacheSecurityGroupInput`](crate::input::CreateCacheSecurityGroupInput)
    pub fn builder() -> crate::input::create_cache_security_group_input::Builder {
        crate::input::create_cache_security_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateCacheSecurityGroup {
    type Output = std::result::Result<
        crate::output::CreateCacheSecurityGroupOutput,
        crate::error::CreateCacheSecurityGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_cache_security_group_error(response)
        } else {
            crate::operation_deser::parse_create_cache_security_group_response(response)
        }
    }
}

/// <p>Creates a new cache subnet group.</p>
/// <p>Use this parameter only when you are creating a cluster in an Amazon Virtual Private Cloud (Amazon VPC).</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateCacheSubnetGroup {
    _private: (),
}
impl CreateCacheSubnetGroup {
    /// Creates a new builder-style object to manufacture [`CreateCacheSubnetGroupInput`](crate::input::CreateCacheSubnetGroupInput)
    pub fn builder() -> crate::input::create_cache_subnet_group_input::Builder {
        crate::input::create_cache_subnet_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateCacheSubnetGroup {
    type Output = std::result::Result<
        crate::output::CreateCacheSubnetGroupOutput,
        crate::error::CreateCacheSubnetGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_cache_subnet_group_error(response)
        } else {
            crate::operation_deser::parse_create_cache_subnet_group_response(response)
        }
    }
}

/// <p>Global Datastore for Redis offers fully managed, fast,
/// reliable and secure cross-region replication.
/// Using Global Datastore for Redis, you can create cross-region
/// read replica clusters for ElastiCache for Redis to enable low-latency reads
/// and disaster recovery across regions. For more information,
/// see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/Redis-Global-Datastore.html">Replication Across Regions Using Global Datastore</a>. </p>
/// <ul>
/// <li>
/// <p>The <b>GlobalReplicationGroupIdSuffix</b> is the name of the Global datastore.</p>
/// </li>
/// <li>
/// <p>The <b>PrimaryReplicationGroupId</b> represents the name of the primary cluster that accepts writes and will replicate updates to the secondary cluster.</p>
/// </li>
/// </ul>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateGlobalReplicationGroup {
    _private: (),
}
impl CreateGlobalReplicationGroup {
    /// Creates a new builder-style object to manufacture [`CreateGlobalReplicationGroupInput`](crate::input::CreateGlobalReplicationGroupInput)
    pub fn builder() -> crate::input::create_global_replication_group_input::Builder {
        crate::input::create_global_replication_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateGlobalReplicationGroup {
    type Output = std::result::Result<
        crate::output::CreateGlobalReplicationGroupOutput,
        crate::error::CreateGlobalReplicationGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_global_replication_group_error(response)
        } else {
            crate::operation_deser::parse_create_global_replication_group_response(response)
        }
    }
}

/// <p>Creates a Redis (cluster mode disabled) or a Redis (cluster mode enabled) replication group.</p>
/// <p>This API can be used to create a standalone regional replication group or a secondary replication group associated with a Global datastore.</p>
/// <p>A Redis (cluster mode disabled) replication group is a collection of clusters,
/// where one of the clusters is a read/write primary and the others are read-only replicas.
/// Writes to the primary are asynchronously propagated to the replicas.</p>
/// <p>A Redis cluster-mode enabled cluster is comprised of from 1 to 90 shards (API/CLI: node groups).
/// Each shard has a primary node and up to 5 read-only replica nodes. The configuration can range from 90 shards and 0 replicas to 15 shards and 5 replicas, which is the maximum number or replicas allowed.
/// </p>
/// <p>The node or shard limit can be increased to a maximum of 500 per cluster if the Redis engine version is 5.0.6 or higher. For example, you can choose to configure a 500 node cluster that ranges between
/// 83 shards (one primary and 5 replicas per shard) and 500 shards (single primary and no replicas). Make sure there are enough available IP addresses to accommodate the increase.
/// Common pitfalls include the subnets in the subnet group have too small a CIDR range or the subnets are shared and heavily used by other clusters. For more information, see
/// <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/SubnetGroups.Creating.html">Creating a Subnet Group</a>. For versions below 5.0.6,
/// the limit is 250 per cluster.</p>
/// <p>To request a limit increase, see
/// <a href="https://docs.aws.amazon.com/general/latest/gr/aws_service_limits.html">Amazon Service Limits</a>
/// and choose the limit type <b>Nodes per cluster per instance type</b>. </p>
/// <p>When a Redis (cluster mode disabled) replication group has been successfully created,
/// you can add one or more read replicas to it, up to a total of 5 read replicas.
/// If you need to increase or decrease the number of node groups (console: shards),
/// you can avail yourself of ElastiCache for Redis' scaling. For more information,
/// see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/Scaling.html">Scaling ElastiCache for Redis Clusters</a> in the <i>ElastiCache User Guide</i>.</p>
/// <note>
/// <p>This operation is valid for Redis only.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateReplicationGroup {
    _private: (),
}
impl CreateReplicationGroup {
    /// Creates a new builder-style object to manufacture [`CreateReplicationGroupInput`](crate::input::CreateReplicationGroupInput)
    pub fn builder() -> crate::input::create_replication_group_input::Builder {
        crate::input::create_replication_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateReplicationGroup {
    type Output = std::result::Result<
        crate::output::CreateReplicationGroupOutput,
        crate::error::CreateReplicationGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_replication_group_error(response)
        } else {
            crate::operation_deser::parse_create_replication_group_response(response)
        }
    }
}

/// <p>Creates a copy of an entire cluster or replication group at a
/// specific moment in time.</p>
/// <note>
/// <p>This operation is valid for Redis only.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateSnapshot {
    _private: (),
}
impl CreateSnapshot {
    /// Creates a new builder-style object to manufacture [`CreateSnapshotInput`](crate::input::CreateSnapshotInput)
    pub fn builder() -> crate::input::create_snapshot_input::Builder {
        crate::input::create_snapshot_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateSnapshot {
    type Output =
        std::result::Result<crate::output::CreateSnapshotOutput, crate::error::CreateSnapshotError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_snapshot_error(response)
        } else {
            crate::operation_deser::parse_create_snapshot_response(response)
        }
    }
}

/// <p>For Redis engine version 6.x onwards: Creates a Redis user. For more information, see <a href="http://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/Clusters.RBAC.html">Using Role Based Access Control (RBAC)</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateUser {
    _private: (),
}
impl CreateUser {
    /// Creates a new builder-style object to manufacture [`CreateUserInput`](crate::input::CreateUserInput)
    pub fn builder() -> crate::input::create_user_input::Builder {
        crate::input::create_user_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateUser {
    type Output =
        std::result::Result<crate::output::CreateUserOutput, crate::error::CreateUserError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_user_error(response)
        } else {
            crate::operation_deser::parse_create_user_response(response)
        }
    }
}

/// <p>For Redis engine version 6.x onwards: Creates a Redis user group. For more information, see <a href="http://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/Clusters.RBAC.html">Using Role Based Access Control (RBAC)</a>
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateUserGroup {
    _private: (),
}
impl CreateUserGroup {
    /// Creates a new builder-style object to manufacture [`CreateUserGroupInput`](crate::input::CreateUserGroupInput)
    pub fn builder() -> crate::input::create_user_group_input::Builder {
        crate::input::create_user_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateUserGroup {
    type Output = std::result::Result<
        crate::output::CreateUserGroupOutput,
        crate::error::CreateUserGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_user_group_error(response)
        } else {
            crate::operation_deser::parse_create_user_group_response(response)
        }
    }
}

/// <p>Decreases the number of node groups in a Global datastore</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DecreaseNodeGroupsInGlobalReplicationGroup {
    _private: (),
}
impl DecreaseNodeGroupsInGlobalReplicationGroup {
    /// Creates a new builder-style object to manufacture [`DecreaseNodeGroupsInGlobalReplicationGroupInput`](crate::input::DecreaseNodeGroupsInGlobalReplicationGroupInput)
    pub fn builder() -> crate::input::decrease_node_groups_in_global_replication_group_input::Builder
    {
        crate::input::decrease_node_groups_in_global_replication_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DecreaseNodeGroupsInGlobalReplicationGroup {
    type Output = std::result::Result<
        crate::output::DecreaseNodeGroupsInGlobalReplicationGroupOutput,
        crate::error::DecreaseNodeGroupsInGlobalReplicationGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_decrease_node_groups_in_global_replication_group_error(
                response,
            )
        } else {
            crate::operation_deser::parse_decrease_node_groups_in_global_replication_group_response(
                response,
            )
        }
    }
}

/// <p>Dynamically decreases the number of replicas in a Redis (cluster mode disabled) replication group or the number of
/// replica nodes in one or more node groups (shards) of a Redis (cluster mode enabled) replication group. This operation
/// is performed with no cluster down time.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DecreaseReplicaCount {
    _private: (),
}
impl DecreaseReplicaCount {
    /// Creates a new builder-style object to manufacture [`DecreaseReplicaCountInput`](crate::input::DecreaseReplicaCountInput)
    pub fn builder() -> crate::input::decrease_replica_count_input::Builder {
        crate::input::decrease_replica_count_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DecreaseReplicaCount {
    type Output = std::result::Result<
        crate::output::DecreaseReplicaCountOutput,
        crate::error::DecreaseReplicaCountError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_decrease_replica_count_error(response)
        } else {
            crate::operation_deser::parse_decrease_replica_count_response(response)
        }
    }
}

/// <p>Deletes a previously provisioned cluster.
/// <code>DeleteCacheCluster</code> deletes all associated cache nodes, node endpoints and the
/// cluster itself. When you receive a successful response from this operation,
/// Amazon ElastiCache immediately begins deleting the cluster; you cannot cancel or revert
/// this operation.</p>
/// <p>This operation is not valid for:</p>
/// <ul>
/// <li>
/// <p>Redis (cluster mode enabled) clusters</p>
/// </li>
/// <li>
/// <p>Redis (cluster mode disabled) clusters</p>
/// </li>
/// <li>
/// <p>A cluster that is the last read replica of a replication group</p>
/// </li>
/// <li>
/// <p>A cluster that is the primary node of a replication group</p>
/// </li>
/// <li>
/// <p>A node group (shard) that has Multi-AZ mode enabled</p>
/// </li>
/// <li>
/// <p>A cluster from a Redis (cluster mode enabled) replication group</p>
/// </li>
/// <li>
/// <p>A cluster that is not in the <code>available</code> state</p>
/// </li>
/// </ul>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteCacheCluster {
    _private: (),
}
impl DeleteCacheCluster {
    /// Creates a new builder-style object to manufacture [`DeleteCacheClusterInput`](crate::input::DeleteCacheClusterInput)
    pub fn builder() -> crate::input::delete_cache_cluster_input::Builder {
        crate::input::delete_cache_cluster_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteCacheCluster {
    type Output = std::result::Result<
        crate::output::DeleteCacheClusterOutput,
        crate::error::DeleteCacheClusterError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_cache_cluster_error(response)
        } else {
            crate::operation_deser::parse_delete_cache_cluster_response(response)
        }
    }
}

/// <p>Deletes the specified cache parameter
/// group. You cannot delete a cache parameter group if it is associated with any cache
/// clusters. You cannot delete the default cache parameter groups in your account.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteCacheParameterGroup {
    _private: (),
}
impl DeleteCacheParameterGroup {
    /// Creates a new builder-style object to manufacture [`DeleteCacheParameterGroupInput`](crate::input::DeleteCacheParameterGroupInput)
    pub fn builder() -> crate::input::delete_cache_parameter_group_input::Builder {
        crate::input::delete_cache_parameter_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteCacheParameterGroup {
    type Output = std::result::Result<
        crate::output::DeleteCacheParameterGroupOutput,
        crate::error::DeleteCacheParameterGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_cache_parameter_group_error(response)
        } else {
            crate::operation_deser::parse_delete_cache_parameter_group_response(response)
        }
    }
}

/// <p>Deletes a cache security group.</p>
/// <note>
/// <p>You cannot delete a cache security group if it is associated with any clusters.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteCacheSecurityGroup {
    _private: (),
}
impl DeleteCacheSecurityGroup {
    /// Creates a new builder-style object to manufacture [`DeleteCacheSecurityGroupInput`](crate::input::DeleteCacheSecurityGroupInput)
    pub fn builder() -> crate::input::delete_cache_security_group_input::Builder {
        crate::input::delete_cache_security_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteCacheSecurityGroup {
    type Output = std::result::Result<
        crate::output::DeleteCacheSecurityGroupOutput,
        crate::error::DeleteCacheSecurityGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_cache_security_group_error(response)
        } else {
            crate::operation_deser::parse_delete_cache_security_group_response(response)
        }
    }
}

/// <p>Deletes a cache subnet group.</p>
/// <note>
/// <p>You cannot delete a default cache subnet group or one that is associated with any clusters.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteCacheSubnetGroup {
    _private: (),
}
impl DeleteCacheSubnetGroup {
    /// Creates a new builder-style object to manufacture [`DeleteCacheSubnetGroupInput`](crate::input::DeleteCacheSubnetGroupInput)
    pub fn builder() -> crate::input::delete_cache_subnet_group_input::Builder {
        crate::input::delete_cache_subnet_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteCacheSubnetGroup {
    type Output = std::result::Result<
        crate::output::DeleteCacheSubnetGroupOutput,
        crate::error::DeleteCacheSubnetGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_cache_subnet_group_error(response)
        } else {
            crate::operation_deser::parse_delete_cache_subnet_group_response(response)
        }
    }
}

/// <p>Deleting a Global datastore is a two-step process: </p>
/// <ul>
/// <li>
/// <p>First, you must <a>DisassociateGlobalReplicationGroup</a> to remove the secondary clusters in the Global datastore.</p>
/// </li>
/// <li>
/// <p>Once the Global datastore contains only the primary cluster, you can use the <code>DeleteGlobalReplicationGroup</code> API to delete the Global datastore while retainining the primary cluster using <code>RetainPrimaryReplicationGroup=true</code>.</p>
/// </li>
/// </ul>
/// <p>Since the Global Datastore has only a primary cluster, you can delete the Global Datastore
/// while retaining the primary by setting <code>RetainPrimaryReplicationGroup=true</code>. The primary cluster is never deleted when deleting a
/// Global Datastore. It can only be deleted when it no longer is associated with any Global Datastore.</p>
/// <p>When you receive a successful response from this operation, Amazon ElastiCache immediately begins deleting the selected resources;
/// you cannot cancel or revert this operation.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteGlobalReplicationGroup {
    _private: (),
}
impl DeleteGlobalReplicationGroup {
    /// Creates a new builder-style object to manufacture [`DeleteGlobalReplicationGroupInput`](crate::input::DeleteGlobalReplicationGroupInput)
    pub fn builder() -> crate::input::delete_global_replication_group_input::Builder {
        crate::input::delete_global_replication_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteGlobalReplicationGroup {
    type Output = std::result::Result<
        crate::output::DeleteGlobalReplicationGroupOutput,
        crate::error::DeleteGlobalReplicationGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_global_replication_group_error(response)
        } else {
            crate::operation_deser::parse_delete_global_replication_group_response(response)
        }
    }
}

/// <p>Deletes an existing replication group.
/// By default, this operation deletes the entire replication group, including the primary/primaries and all of the read replicas.
/// If the replication group has only one primary,
/// you can optionally delete only the read replicas, while retaining the primary by setting <code>RetainPrimaryCluster=true</code>.</p>
/// <p>When you receive a successful response from this operation, Amazon ElastiCache immediately begins deleting the selected resources;
/// you cannot cancel or revert this operation.</p>
/// <note>
/// <p>This operation is valid for Redis only.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteReplicationGroup {
    _private: (),
}
impl DeleteReplicationGroup {
    /// Creates a new builder-style object to manufacture [`DeleteReplicationGroupInput`](crate::input::DeleteReplicationGroupInput)
    pub fn builder() -> crate::input::delete_replication_group_input::Builder {
        crate::input::delete_replication_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteReplicationGroup {
    type Output = std::result::Result<
        crate::output::DeleteReplicationGroupOutput,
        crate::error::DeleteReplicationGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_replication_group_error(response)
        } else {
            crate::operation_deser::parse_delete_replication_group_response(response)
        }
    }
}

/// <p>Deletes an existing snapshot. When you receive a
/// successful response from this operation, ElastiCache immediately begins deleting the snapshot;
/// you cannot cancel or revert this operation.</p>
/// <note>
/// <p>This operation is valid for Redis only.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteSnapshot {
    _private: (),
}
impl DeleteSnapshot {
    /// Creates a new builder-style object to manufacture [`DeleteSnapshotInput`](crate::input::DeleteSnapshotInput)
    pub fn builder() -> crate::input::delete_snapshot_input::Builder {
        crate::input::delete_snapshot_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteSnapshot {
    type Output =
        std::result::Result<crate::output::DeleteSnapshotOutput, crate::error::DeleteSnapshotError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_snapshot_error(response)
        } else {
            crate::operation_deser::parse_delete_snapshot_response(response)
        }
    }
}

/// <p>For Redis engine version 6.x onwards: Deletes a user. The user will be removed from all user groups and in turn removed from all replication groups. For more information, see <a href="http://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/Clusters.RBAC.html">Using Role Based Access Control (RBAC)</a>. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteUser {
    _private: (),
}
impl DeleteUser {
    /// Creates a new builder-style object to manufacture [`DeleteUserInput`](crate::input::DeleteUserInput)
    pub fn builder() -> crate::input::delete_user_input::Builder {
        crate::input::delete_user_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteUser {
    type Output =
        std::result::Result<crate::output::DeleteUserOutput, crate::error::DeleteUserError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_user_error(response)
        } else {
            crate::operation_deser::parse_delete_user_response(response)
        }
    }
}

/// <p>For Redis engine version 6.x onwards: Deletes a user group. The user group must first be disassociated from the replication group before it can be deleted. For more information, see <a href="http://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/Clusters.RBAC.html">Using Role Based Access Control (RBAC)</a>. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteUserGroup {
    _private: (),
}
impl DeleteUserGroup {
    /// Creates a new builder-style object to manufacture [`DeleteUserGroupInput`](crate::input::DeleteUserGroupInput)
    pub fn builder() -> crate::input::delete_user_group_input::Builder {
        crate::input::delete_user_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteUserGroup {
    type Output = std::result::Result<
        crate::output::DeleteUserGroupOutput,
        crate::error::DeleteUserGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_user_group_error(response)
        } else {
            crate::operation_deser::parse_delete_user_group_response(response)
        }
    }
}

/// <p>Returns information about all provisioned
/// clusters if no cluster identifier is specified, or about a specific cache
/// cluster if a cluster identifier is supplied.</p>
/// <p>By default, abbreviated information about the clusters is returned. You can
/// use the optional <i>ShowCacheNodeInfo</i> flag to retrieve detailed information about the
/// cache nodes associated with the clusters. These details include the DNS address
/// and port for the cache node endpoint.</p>
/// <p>If the cluster is in the <i>creating</i> state, only cluster-level information is displayed
/// until all of the nodes are successfully provisioned.</p>
/// <p>If the cluster is in the <i>deleting</i> state, only cluster-level information is displayed.</p>
/// <p>If cache nodes are currently being added to the cluster, node endpoint information
/// and creation time for the additional nodes are not displayed until they are
/// completely provisioned. When the cluster state is <i>available</i>, the cluster is
/// ready for use.</p>
/// <p>If cache nodes are currently being removed from the cluster, no endpoint information
/// for the removed nodes is displayed.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeCacheClusters {
    _private: (),
}
impl DescribeCacheClusters {
    /// Creates a new builder-style object to manufacture [`DescribeCacheClustersInput`](crate::input::DescribeCacheClustersInput)
    pub fn builder() -> crate::input::describe_cache_clusters_input::Builder {
        crate::input::describe_cache_clusters_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeCacheClusters {
    type Output = std::result::Result<
        crate::output::DescribeCacheClustersOutput,
        crate::error::DescribeCacheClustersError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_cache_clusters_error(response)
        } else {
            crate::operation_deser::parse_describe_cache_clusters_response(response)
        }
    }
}

/// <p>Returns a list of the available cache
/// engines and their versions.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeCacheEngineVersions {
    _private: (),
}
impl DescribeCacheEngineVersions {
    /// Creates a new builder-style object to manufacture [`DescribeCacheEngineVersionsInput`](crate::input::DescribeCacheEngineVersionsInput)
    pub fn builder() -> crate::input::describe_cache_engine_versions_input::Builder {
        crate::input::describe_cache_engine_versions_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeCacheEngineVersions {
    type Output = std::result::Result<
        crate::output::DescribeCacheEngineVersionsOutput,
        crate::error::DescribeCacheEngineVersionsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_cache_engine_versions_error(response)
        } else {
            crate::operation_deser::parse_describe_cache_engine_versions_response(response)
        }
    }
}

/// <p>Returns a list of cache parameter group
/// descriptions. If a cache parameter group name is specified, the list contains only
/// the descriptions for that group.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeCacheParameterGroups {
    _private: (),
}
impl DescribeCacheParameterGroups {
    /// Creates a new builder-style object to manufacture [`DescribeCacheParameterGroupsInput`](crate::input::DescribeCacheParameterGroupsInput)
    pub fn builder() -> crate::input::describe_cache_parameter_groups_input::Builder {
        crate::input::describe_cache_parameter_groups_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeCacheParameterGroups {
    type Output = std::result::Result<
        crate::output::DescribeCacheParameterGroupsOutput,
        crate::error::DescribeCacheParameterGroupsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_cache_parameter_groups_error(response)
        } else {
            crate::operation_deser::parse_describe_cache_parameter_groups_response(response)
        }
    }
}

/// <p>Returns the detailed parameter list for a
/// particular cache parameter group.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeCacheParameters {
    _private: (),
}
impl DescribeCacheParameters {
    /// Creates a new builder-style object to manufacture [`DescribeCacheParametersInput`](crate::input::DescribeCacheParametersInput)
    pub fn builder() -> crate::input::describe_cache_parameters_input::Builder {
        crate::input::describe_cache_parameters_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeCacheParameters {
    type Output = std::result::Result<
        crate::output::DescribeCacheParametersOutput,
        crate::error::DescribeCacheParametersError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_cache_parameters_error(response)
        } else {
            crate::operation_deser::parse_describe_cache_parameters_response(response)
        }
    }
}

/// <p>Returns a list of cache security group
/// descriptions. If a cache security group name is specified, the list contains only
/// the description of that group. This applicable only when you have ElastiCache in Classic setup
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeCacheSecurityGroups {
    _private: (),
}
impl DescribeCacheSecurityGroups {
    /// Creates a new builder-style object to manufacture [`DescribeCacheSecurityGroupsInput`](crate::input::DescribeCacheSecurityGroupsInput)
    pub fn builder() -> crate::input::describe_cache_security_groups_input::Builder {
        crate::input::describe_cache_security_groups_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeCacheSecurityGroups {
    type Output = std::result::Result<
        crate::output::DescribeCacheSecurityGroupsOutput,
        crate::error::DescribeCacheSecurityGroupsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_cache_security_groups_error(response)
        } else {
            crate::operation_deser::parse_describe_cache_security_groups_response(response)
        }
    }
}

/// <p>Returns a list of cache subnet group
/// descriptions. If a subnet group name is specified, the list  contains only the
/// description of that group. This is applicable only when you have ElastiCache in VPC setup. All ElastiCache clusters now launch in VPC by default.
/// </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeCacheSubnetGroups {
    _private: (),
}
impl DescribeCacheSubnetGroups {
    /// Creates a new builder-style object to manufacture [`DescribeCacheSubnetGroupsInput`](crate::input::DescribeCacheSubnetGroupsInput)
    pub fn builder() -> crate::input::describe_cache_subnet_groups_input::Builder {
        crate::input::describe_cache_subnet_groups_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeCacheSubnetGroups {
    type Output = std::result::Result<
        crate::output::DescribeCacheSubnetGroupsOutput,
        crate::error::DescribeCacheSubnetGroupsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_cache_subnet_groups_error(response)
        } else {
            crate::operation_deser::parse_describe_cache_subnet_groups_response(response)
        }
    }
}

/// <p>Returns the default engine and
/// system parameter information for the specified cache engine.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeEngineDefaultParameters {
    _private: (),
}
impl DescribeEngineDefaultParameters {
    /// Creates a new builder-style object to manufacture [`DescribeEngineDefaultParametersInput`](crate::input::DescribeEngineDefaultParametersInput)
    pub fn builder() -> crate::input::describe_engine_default_parameters_input::Builder {
        crate::input::describe_engine_default_parameters_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeEngineDefaultParameters {
    type Output = std::result::Result<
        crate::output::DescribeEngineDefaultParametersOutput,
        crate::error::DescribeEngineDefaultParametersError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_engine_default_parameters_error(response)
        } else {
            crate::operation_deser::parse_describe_engine_default_parameters_response(response)
        }
    }
}

/// <p>Returns events related to clusters, cache
/// security groups, and cache parameter groups. You can obtain events specific to a
/// particular cluster, cache security group, or cache parameter group by providing
/// the name as a parameter.</p>
/// <p>By default, only the events occurring within the last hour are returned;
/// however, you can retrieve up to 14 days' worth of events if necessary.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeEvents {
    _private: (),
}
impl DescribeEvents {
    /// Creates a new builder-style object to manufacture [`DescribeEventsInput`](crate::input::DescribeEventsInput)
    pub fn builder() -> crate::input::describe_events_input::Builder {
        crate::input::describe_events_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeEvents {
    type Output =
        std::result::Result<crate::output::DescribeEventsOutput, crate::error::DescribeEventsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_events_error(response)
        } else {
            crate::operation_deser::parse_describe_events_response(response)
        }
    }
}

/// <p>Returns information about a particular global replication group. If no identifier is specified, returns information about all Global datastores. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeGlobalReplicationGroups {
    _private: (),
}
impl DescribeGlobalReplicationGroups {
    /// Creates a new builder-style object to manufacture [`DescribeGlobalReplicationGroupsInput`](crate::input::DescribeGlobalReplicationGroupsInput)
    pub fn builder() -> crate::input::describe_global_replication_groups_input::Builder {
        crate::input::describe_global_replication_groups_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeGlobalReplicationGroups {
    type Output = std::result::Result<
        crate::output::DescribeGlobalReplicationGroupsOutput,
        crate::error::DescribeGlobalReplicationGroupsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_global_replication_groups_error(response)
        } else {
            crate::operation_deser::parse_describe_global_replication_groups_response(response)
        }
    }
}

/// <p>Returns information about a particular
/// replication group. If no identifier is specified, <code>DescribeReplicationGroups</code>
/// returns information about all replication groups.</p>
/// <note>
/// <p>This operation is valid for Redis only.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeReplicationGroups {
    _private: (),
}
impl DescribeReplicationGroups {
    /// Creates a new builder-style object to manufacture [`DescribeReplicationGroupsInput`](crate::input::DescribeReplicationGroupsInput)
    pub fn builder() -> crate::input::describe_replication_groups_input::Builder {
        crate::input::describe_replication_groups_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeReplicationGroups {
    type Output = std::result::Result<
        crate::output::DescribeReplicationGroupsOutput,
        crate::error::DescribeReplicationGroupsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_replication_groups_error(response)
        } else {
            crate::operation_deser::parse_describe_replication_groups_response(response)
        }
    }
}

/// <p>Returns information about reserved cache
/// nodes for this account, or about a specified reserved cache node.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeReservedCacheNodes {
    _private: (),
}
impl DescribeReservedCacheNodes {
    /// Creates a new builder-style object to manufacture [`DescribeReservedCacheNodesInput`](crate::input::DescribeReservedCacheNodesInput)
    pub fn builder() -> crate::input::describe_reserved_cache_nodes_input::Builder {
        crate::input::describe_reserved_cache_nodes_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeReservedCacheNodes {
    type Output = std::result::Result<
        crate::output::DescribeReservedCacheNodesOutput,
        crate::error::DescribeReservedCacheNodesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_reserved_cache_nodes_error(response)
        } else {
            crate::operation_deser::parse_describe_reserved_cache_nodes_response(response)
        }
    }
}

/// <p>Lists available reserved cache
/// node offerings.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeReservedCacheNodesOfferings {
    _private: (),
}
impl DescribeReservedCacheNodesOfferings {
    /// Creates a new builder-style object to manufacture [`DescribeReservedCacheNodesOfferingsInput`](crate::input::DescribeReservedCacheNodesOfferingsInput)
    pub fn builder() -> crate::input::describe_reserved_cache_nodes_offerings_input::Builder {
        crate::input::describe_reserved_cache_nodes_offerings_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeReservedCacheNodesOfferings {
    type Output = std::result::Result<
        crate::output::DescribeReservedCacheNodesOfferingsOutput,
        crate::error::DescribeReservedCacheNodesOfferingsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_reserved_cache_nodes_offerings_error(response)
        } else {
            crate::operation_deser::parse_describe_reserved_cache_nodes_offerings_response(response)
        }
    }
}

/// <p>Returns details of the service updates</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeServiceUpdates {
    _private: (),
}
impl DescribeServiceUpdates {
    /// Creates a new builder-style object to manufacture [`DescribeServiceUpdatesInput`](crate::input::DescribeServiceUpdatesInput)
    pub fn builder() -> crate::input::describe_service_updates_input::Builder {
        crate::input::describe_service_updates_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeServiceUpdates {
    type Output = std::result::Result<
        crate::output::DescribeServiceUpdatesOutput,
        crate::error::DescribeServiceUpdatesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_service_updates_error(response)
        } else {
            crate::operation_deser::parse_describe_service_updates_response(response)
        }
    }
}

/// <p>Returns information about cluster or replication group snapshots.
/// By default, <code>DescribeSnapshots</code> lists all of your snapshots; it can optionally
/// describe a single snapshot, or just the snapshots associated with a particular cache
/// cluster.</p>
/// <note>
/// <p>This operation is valid for Redis only.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeSnapshots {
    _private: (),
}
impl DescribeSnapshots {
    /// Creates a new builder-style object to manufacture [`DescribeSnapshotsInput`](crate::input::DescribeSnapshotsInput)
    pub fn builder() -> crate::input::describe_snapshots_input::Builder {
        crate::input::describe_snapshots_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeSnapshots {
    type Output = std::result::Result<
        crate::output::DescribeSnapshotsOutput,
        crate::error::DescribeSnapshotsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_snapshots_error(response)
        } else {
            crate::operation_deser::parse_describe_snapshots_response(response)
        }
    }
}

/// <p>Returns details of the update actions </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeUpdateActions {
    _private: (),
}
impl DescribeUpdateActions {
    /// Creates a new builder-style object to manufacture [`DescribeUpdateActionsInput`](crate::input::DescribeUpdateActionsInput)
    pub fn builder() -> crate::input::describe_update_actions_input::Builder {
        crate::input::describe_update_actions_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeUpdateActions {
    type Output = std::result::Result<
        crate::output::DescribeUpdateActionsOutput,
        crate::error::DescribeUpdateActionsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_update_actions_error(response)
        } else {
            crate::operation_deser::parse_describe_update_actions_response(response)
        }
    }
}

/// <p>Returns a list of user groups.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeUserGroups {
    _private: (),
}
impl DescribeUserGroups {
    /// Creates a new builder-style object to manufacture [`DescribeUserGroupsInput`](crate::input::DescribeUserGroupsInput)
    pub fn builder() -> crate::input::describe_user_groups_input::Builder {
        crate::input::describe_user_groups_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeUserGroups {
    type Output = std::result::Result<
        crate::output::DescribeUserGroupsOutput,
        crate::error::DescribeUserGroupsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_user_groups_error(response)
        } else {
            crate::operation_deser::parse_describe_user_groups_response(response)
        }
    }
}

/// <p>Returns a list of users.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeUsers {
    _private: (),
}
impl DescribeUsers {
    /// Creates a new builder-style object to manufacture [`DescribeUsersInput`](crate::input::DescribeUsersInput)
    pub fn builder() -> crate::input::describe_users_input::Builder {
        crate::input::describe_users_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeUsers {
    type Output =
        std::result::Result<crate::output::DescribeUsersOutput, crate::error::DescribeUsersError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_users_error(response)
        } else {
            crate::operation_deser::parse_describe_users_response(response)
        }
    }
}

/// <p>Remove a secondary cluster from the Global datastore using the Global datastore name. The secondary cluster will no longer receive updates from the primary cluster, but will remain as a standalone cluster in that Amazon region.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DisassociateGlobalReplicationGroup {
    _private: (),
}
impl DisassociateGlobalReplicationGroup {
    /// Creates a new builder-style object to manufacture [`DisassociateGlobalReplicationGroupInput`](crate::input::DisassociateGlobalReplicationGroupInput)
    pub fn builder() -> crate::input::disassociate_global_replication_group_input::Builder {
        crate::input::disassociate_global_replication_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DisassociateGlobalReplicationGroup {
    type Output = std::result::Result<
        crate::output::DisassociateGlobalReplicationGroupOutput,
        crate::error::DisassociateGlobalReplicationGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_disassociate_global_replication_group_error(response)
        } else {
            crate::operation_deser::parse_disassociate_global_replication_group_response(response)
        }
    }
}

/// <p>Used to failover the primary region to a selected secondary region. The selected secondary region will become primary, and all other clusters will become secondary.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct FailoverGlobalReplicationGroup {
    _private: (),
}
impl FailoverGlobalReplicationGroup {
    /// Creates a new builder-style object to manufacture [`FailoverGlobalReplicationGroupInput`](crate::input::FailoverGlobalReplicationGroupInput)
    pub fn builder() -> crate::input::failover_global_replication_group_input::Builder {
        crate::input::failover_global_replication_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for FailoverGlobalReplicationGroup {
    type Output = std::result::Result<
        crate::output::FailoverGlobalReplicationGroupOutput,
        crate::error::FailoverGlobalReplicationGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_failover_global_replication_group_error(response)
        } else {
            crate::operation_deser::parse_failover_global_replication_group_response(response)
        }
    }
}

/// <p>Increase the number of node groups in the Global datastore</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct IncreaseNodeGroupsInGlobalReplicationGroup {
    _private: (),
}
impl IncreaseNodeGroupsInGlobalReplicationGroup {
    /// Creates a new builder-style object to manufacture [`IncreaseNodeGroupsInGlobalReplicationGroupInput`](crate::input::IncreaseNodeGroupsInGlobalReplicationGroupInput)
    pub fn builder() -> crate::input::increase_node_groups_in_global_replication_group_input::Builder
    {
        crate::input::increase_node_groups_in_global_replication_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for IncreaseNodeGroupsInGlobalReplicationGroup {
    type Output = std::result::Result<
        crate::output::IncreaseNodeGroupsInGlobalReplicationGroupOutput,
        crate::error::IncreaseNodeGroupsInGlobalReplicationGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_increase_node_groups_in_global_replication_group_error(
                response,
            )
        } else {
            crate::operation_deser::parse_increase_node_groups_in_global_replication_group_response(
                response,
            )
        }
    }
}

/// <p>Dynamically increases the number of replicas in a Redis (cluster mode disabled) replication group or the number of
/// replica nodes in one or more node groups (shards) of a Redis (cluster mode enabled) replication group. This operation
/// is performed with no cluster down time.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct IncreaseReplicaCount {
    _private: (),
}
impl IncreaseReplicaCount {
    /// Creates a new builder-style object to manufacture [`IncreaseReplicaCountInput`](crate::input::IncreaseReplicaCountInput)
    pub fn builder() -> crate::input::increase_replica_count_input::Builder {
        crate::input::increase_replica_count_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for IncreaseReplicaCount {
    type Output = std::result::Result<
        crate::output::IncreaseReplicaCountOutput,
        crate::error::IncreaseReplicaCountError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_increase_replica_count_error(response)
        } else {
            crate::operation_deser::parse_increase_replica_count_response(response)
        }
    }
}

/// <p>Lists all available node types that you
/// can scale your Redis cluster's or replication group's current node type.</p>
/// <p>When you use the <code>ModifyCacheCluster</code> or <code>ModifyReplicationGroup</code> operations to
/// scale your cluster or replication group, the value of the <code>CacheNodeType</code> parameter
/// must be one of the node types returned by this operation.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListAllowedNodeTypeModifications {
    _private: (),
}
impl ListAllowedNodeTypeModifications {
    /// Creates a new builder-style object to manufacture [`ListAllowedNodeTypeModificationsInput`](crate::input::ListAllowedNodeTypeModificationsInput)
    pub fn builder() -> crate::input::list_allowed_node_type_modifications_input::Builder {
        crate::input::list_allowed_node_type_modifications_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListAllowedNodeTypeModifications {
    type Output = std::result::Result<
        crate::output::ListAllowedNodeTypeModificationsOutput,
        crate::error::ListAllowedNodeTypeModificationsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_allowed_node_type_modifications_error(response)
        } else {
            crate::operation_deser::parse_list_allowed_node_type_modifications_response(response)
        }
    }
}

/// <p>Lists all tags currently on a  named resource.</p>
/// <p>    A  tag is a key-value pair where the key and value are case-sensitive.            
/// You can use tags to categorize and track all your ElastiCache resources, with the exception of global replication group. When you add or remove tags on replication groups, those actions will be replicated to all nodes in the replication group.
/// For more information, see <a href="http://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/IAM.ResourceLevelPermissions.html">Resource-level permissions</a>.</p>
/// <p>If the cluster is not in the <i>available</i> state, <code>ListTagsForResource</code>
/// returns an error.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListTagsForResource {
    _private: (),
}
impl ListTagsForResource {
    /// Creates a new builder-style object to manufacture [`ListTagsForResourceInput`](crate::input::ListTagsForResourceInput)
    pub fn builder() -> crate::input::list_tags_for_resource_input::Builder {
        crate::input::list_tags_for_resource_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListTagsForResource {
    type Output = std::result::Result<
        crate::output::ListTagsForResourceOutput,
        crate::error::ListTagsForResourceError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_tags_for_resource_error(response)
        } else {
            crate::operation_deser::parse_list_tags_for_resource_response(response)
        }
    }
}

/// <p>Modifies the settings for a cluster. You
/// can use this operation to change one or more cluster configuration parameters by
/// specifying the parameters and the new values.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ModifyCacheCluster {
    _private: (),
}
impl ModifyCacheCluster {
    /// Creates a new builder-style object to manufacture [`ModifyCacheClusterInput`](crate::input::ModifyCacheClusterInput)
    pub fn builder() -> crate::input::modify_cache_cluster_input::Builder {
        crate::input::modify_cache_cluster_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ModifyCacheCluster {
    type Output = std::result::Result<
        crate::output::ModifyCacheClusterOutput,
        crate::error::ModifyCacheClusterError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_modify_cache_cluster_error(response)
        } else {
            crate::operation_deser::parse_modify_cache_cluster_response(response)
        }
    }
}

/// <p>Modifies the parameters of a cache
/// parameter group. You can modify up to 20 parameters in a single request by submitting a
/// list parameter name and value pairs.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ModifyCacheParameterGroup {
    _private: (),
}
impl ModifyCacheParameterGroup {
    /// Creates a new builder-style object to manufacture [`ModifyCacheParameterGroupInput`](crate::input::ModifyCacheParameterGroupInput)
    pub fn builder() -> crate::input::modify_cache_parameter_group_input::Builder {
        crate::input::modify_cache_parameter_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ModifyCacheParameterGroup {
    type Output = std::result::Result<
        crate::output::ModifyCacheParameterGroupOutput,
        crate::error::ModifyCacheParameterGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_modify_cache_parameter_group_error(response)
        } else {
            crate::operation_deser::parse_modify_cache_parameter_group_response(response)
        }
    }
}

/// <p>Modifies an existing cache subnet group.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ModifyCacheSubnetGroup {
    _private: (),
}
impl ModifyCacheSubnetGroup {
    /// Creates a new builder-style object to manufacture [`ModifyCacheSubnetGroupInput`](crate::input::ModifyCacheSubnetGroupInput)
    pub fn builder() -> crate::input::modify_cache_subnet_group_input::Builder {
        crate::input::modify_cache_subnet_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ModifyCacheSubnetGroup {
    type Output = std::result::Result<
        crate::output::ModifyCacheSubnetGroupOutput,
        crate::error::ModifyCacheSubnetGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_modify_cache_subnet_group_error(response)
        } else {
            crate::operation_deser::parse_modify_cache_subnet_group_response(response)
        }
    }
}

/// <p>Modifies the settings for a Global datastore.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ModifyGlobalReplicationGroup {
    _private: (),
}
impl ModifyGlobalReplicationGroup {
    /// Creates a new builder-style object to manufacture [`ModifyGlobalReplicationGroupInput`](crate::input::ModifyGlobalReplicationGroupInput)
    pub fn builder() -> crate::input::modify_global_replication_group_input::Builder {
        crate::input::modify_global_replication_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ModifyGlobalReplicationGroup {
    type Output = std::result::Result<
        crate::output::ModifyGlobalReplicationGroupOutput,
        crate::error::ModifyGlobalReplicationGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_modify_global_replication_group_error(response)
        } else {
            crate::operation_deser::parse_modify_global_replication_group_response(response)
        }
    }
}

/// <p>Modifies the settings for a replication group.</p>
/// <ul>
/// <li>
/// <p>
/// <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/scaling-redis-cluster-mode-enabled.html">Scaling for Amazon ElastiCache for Redis (cluster mode enabled)</a>
/// in the ElastiCache User Guide</p>
/// </li>
/// <li>
/// <p>
/// <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/APIReference/API_ModifyReplicationGroupShardConfiguration.html">ModifyReplicationGroupShardConfiguration</a>
/// in the ElastiCache API Reference</p>
/// </li>
/// </ul>
/// <note>
/// <p>This operation is valid for Redis only.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ModifyReplicationGroup {
    _private: (),
}
impl ModifyReplicationGroup {
    /// Creates a new builder-style object to manufacture [`ModifyReplicationGroupInput`](crate::input::ModifyReplicationGroupInput)
    pub fn builder() -> crate::input::modify_replication_group_input::Builder {
        crate::input::modify_replication_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ModifyReplicationGroup {
    type Output = std::result::Result<
        crate::output::ModifyReplicationGroupOutput,
        crate::error::ModifyReplicationGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_modify_replication_group_error(response)
        } else {
            crate::operation_deser::parse_modify_replication_group_response(response)
        }
    }
}

/// <p>Modifies a replication group's shards (node groups) by allowing you to
/// add shards, remove shards, or rebalance the keyspaces among existing shards.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ModifyReplicationGroupShardConfiguration {
    _private: (),
}
impl ModifyReplicationGroupShardConfiguration {
    /// Creates a new builder-style object to manufacture [`ModifyReplicationGroupShardConfigurationInput`](crate::input::ModifyReplicationGroupShardConfigurationInput)
    pub fn builder() -> crate::input::modify_replication_group_shard_configuration_input::Builder {
        crate::input::modify_replication_group_shard_configuration_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ModifyReplicationGroupShardConfiguration {
    type Output = std::result::Result<
        crate::output::ModifyReplicationGroupShardConfigurationOutput,
        crate::error::ModifyReplicationGroupShardConfigurationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_modify_replication_group_shard_configuration_error(
                response,
            )
        } else {
            crate::operation_deser::parse_modify_replication_group_shard_configuration_response(
                response,
            )
        }
    }
}

/// <p>Changes user password(s) and/or access string.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ModifyUser {
    _private: (),
}
impl ModifyUser {
    /// Creates a new builder-style object to manufacture [`ModifyUserInput`](crate::input::ModifyUserInput)
    pub fn builder() -> crate::input::modify_user_input::Builder {
        crate::input::modify_user_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ModifyUser {
    type Output =
        std::result::Result<crate::output::ModifyUserOutput, crate::error::ModifyUserError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_modify_user_error(response)
        } else {
            crate::operation_deser::parse_modify_user_response(response)
        }
    }
}

/// <p>Changes the list of users that belong to the user group.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ModifyUserGroup {
    _private: (),
}
impl ModifyUserGroup {
    /// Creates a new builder-style object to manufacture [`ModifyUserGroupInput`](crate::input::ModifyUserGroupInput)
    pub fn builder() -> crate::input::modify_user_group_input::Builder {
        crate::input::modify_user_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ModifyUserGroup {
    type Output = std::result::Result<
        crate::output::ModifyUserGroupOutput,
        crate::error::ModifyUserGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_modify_user_group_error(response)
        } else {
            crate::operation_deser::parse_modify_user_group_response(response)
        }
    }
}

/// <p>Allows you to purchase a reserved
/// cache node offering. Reserved nodes are not eligible for cancellation and are non-refundable. For more information,
/// see <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/reserved-nodes.html">Managing Costs with Reserved Nodes</a> for Redis or
/// <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/mem-ug/reserved-nodes.html">Managing Costs with Reserved Nodes</a> for Memcached.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PurchaseReservedCacheNodesOffering {
    _private: (),
}
impl PurchaseReservedCacheNodesOffering {
    /// Creates a new builder-style object to manufacture [`PurchaseReservedCacheNodesOfferingInput`](crate::input::PurchaseReservedCacheNodesOfferingInput)
    pub fn builder() -> crate::input::purchase_reserved_cache_nodes_offering_input::Builder {
        crate::input::purchase_reserved_cache_nodes_offering_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PurchaseReservedCacheNodesOffering {
    type Output = std::result::Result<
        crate::output::PurchaseReservedCacheNodesOfferingOutput,
        crate::error::PurchaseReservedCacheNodesOfferingError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_purchase_reserved_cache_nodes_offering_error(response)
        } else {
            crate::operation_deser::parse_purchase_reserved_cache_nodes_offering_response(response)
        }
    }
}

/// <p>Redistribute slots to ensure uniform distribution across existing shards in the cluster.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RebalanceSlotsInGlobalReplicationGroup {
    _private: (),
}
impl RebalanceSlotsInGlobalReplicationGroup {
    /// Creates a new builder-style object to manufacture [`RebalanceSlotsInGlobalReplicationGroupInput`](crate::input::RebalanceSlotsInGlobalReplicationGroupInput)
    pub fn builder() -> crate::input::rebalance_slots_in_global_replication_group_input::Builder {
        crate::input::rebalance_slots_in_global_replication_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RebalanceSlotsInGlobalReplicationGroup {
    type Output = std::result::Result<
        crate::output::RebalanceSlotsInGlobalReplicationGroupOutput,
        crate::error::RebalanceSlotsInGlobalReplicationGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_rebalance_slots_in_global_replication_group_error(
                response,
            )
        } else {
            crate::operation_deser::parse_rebalance_slots_in_global_replication_group_response(
                response,
            )
        }
    }
}

/// <p>Reboots some, or all, of the cache nodes
/// within a provisioned cluster. This operation applies any modified cache parameter
/// groups to the cluster. The reboot operation takes place as soon as possible, and
/// results in a momentary outage to the cluster. During the reboot, the cluster
/// status is set to REBOOTING.</p>
/// <p>The reboot causes the contents of the cache (for each cache node being rebooted) to be lost.</p>
/// <p>When the reboot is complete, a cluster event is created.</p>
/// <p>Rebooting a cluster is currently supported on Memcached and Redis (cluster mode disabled) clusters.
/// Rebooting is not supported on Redis (cluster mode enabled) clusters.</p>
/// <p>If you make changes to parameters that require a Redis (cluster mode enabled) cluster reboot for the changes to be applied,
/// see <a href="http://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/Clusters.Rebooting.html">Rebooting a Cluster</a> for an alternate process.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RebootCacheCluster {
    _private: (),
}
impl RebootCacheCluster {
    /// Creates a new builder-style object to manufacture [`RebootCacheClusterInput`](crate::input::RebootCacheClusterInput)
    pub fn builder() -> crate::input::reboot_cache_cluster_input::Builder {
        crate::input::reboot_cache_cluster_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RebootCacheCluster {
    type Output = std::result::Result<
        crate::output::RebootCacheClusterOutput,
        crate::error::RebootCacheClusterError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_reboot_cache_cluster_error(response)
        } else {
            crate::operation_deser::parse_reboot_cache_cluster_response(response)
        }
    }
}

/// <p>Removes the tags identified by the <code>TagKeys</code>
/// list from the named resource. A  tag is a key-value pair where the key and value are case-sensitive.            
/// You can use tags to categorize and track all your ElastiCache resources, with the exception of global replication group. When you add or remove tags on replication groups, those actions will be replicated to all nodes in the replication group.
/// For more information, see <a href="http://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/IAM.ResourceLevelPermissions.html">Resource-level permissions</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RemoveTagsFromResource {
    _private: (),
}
impl RemoveTagsFromResource {
    /// Creates a new builder-style object to manufacture [`RemoveTagsFromResourceInput`](crate::input::RemoveTagsFromResourceInput)
    pub fn builder() -> crate::input::remove_tags_from_resource_input::Builder {
        crate::input::remove_tags_from_resource_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RemoveTagsFromResource {
    type Output = std::result::Result<
        crate::output::RemoveTagsFromResourceOutput,
        crate::error::RemoveTagsFromResourceError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_remove_tags_from_resource_error(response)
        } else {
            crate::operation_deser::parse_remove_tags_from_resource_response(response)
        }
    }
}

/// <p>Modifies the parameters of a cache
/// parameter group to the engine or system default value. You can reset specific parameters
/// by submitting a list of parameter names. To reset the entire cache parameter group,
/// specify the <code>ResetAllParameters</code> and <code>CacheParameterGroupName</code> parameters.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ResetCacheParameterGroup {
    _private: (),
}
impl ResetCacheParameterGroup {
    /// Creates a new builder-style object to manufacture [`ResetCacheParameterGroupInput`](crate::input::ResetCacheParameterGroupInput)
    pub fn builder() -> crate::input::reset_cache_parameter_group_input::Builder {
        crate::input::reset_cache_parameter_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ResetCacheParameterGroup {
    type Output = std::result::Result<
        crate::output::ResetCacheParameterGroupOutput,
        crate::error::ResetCacheParameterGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_reset_cache_parameter_group_error(response)
        } else {
            crate::operation_deser::parse_reset_cache_parameter_group_response(response)
        }
    }
}

/// <p>Revokes ingress from a cache security group.
/// Use this operation to disallow access from an Amazon EC2 security group
/// that had been previously authorized.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RevokeCacheSecurityGroupIngress {
    _private: (),
}
impl RevokeCacheSecurityGroupIngress {
    /// Creates a new builder-style object to manufacture [`RevokeCacheSecurityGroupIngressInput`](crate::input::RevokeCacheSecurityGroupIngressInput)
    pub fn builder() -> crate::input::revoke_cache_security_group_ingress_input::Builder {
        crate::input::revoke_cache_security_group_ingress_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RevokeCacheSecurityGroupIngress {
    type Output = std::result::Result<
        crate::output::RevokeCacheSecurityGroupIngressOutput,
        crate::error::RevokeCacheSecurityGroupIngressError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_revoke_cache_security_group_ingress_error(response)
        } else {
            crate::operation_deser::parse_revoke_cache_security_group_ingress_response(response)
        }
    }
}

/// <p>Start the migration of data.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct StartMigration {
    _private: (),
}
impl StartMigration {
    /// Creates a new builder-style object to manufacture [`StartMigrationInput`](crate::input::StartMigrationInput)
    pub fn builder() -> crate::input::start_migration_input::Builder {
        crate::input::start_migration_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for StartMigration {
    type Output =
        std::result::Result<crate::output::StartMigrationOutput, crate::error::StartMigrationError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_start_migration_error(response)
        } else {
            crate::operation_deser::parse_start_migration_response(response)
        }
    }
}

/// <p>Represents the input of a <code>TestFailover</code> operation which test automatic failover on
/// a specified node group (called shard in the console) in a replication group (called cluster in the console).</p>
/// <p class="title">
/// <b>Note the following</b>
/// </p>
/// <ul>
/// <li>
/// <p>A customer can use this operation to test automatic failover on up to 5 shards (called node groups in the ElastiCache API and Amazon CLI)
/// in any rolling 24-hour period.</p>
/// </li>
/// <li>
/// <p>If calling this operation on shards in different clusters (called replication groups in the API and CLI), the calls can be made concurrently.</p>
/// <p> </p>
/// </li>
/// <li>
/// <p>If calling this operation multiple times on different shards in the same Redis (cluster mode enabled) replication group,
/// the first node replacement must complete before a subsequent call can be made.</p>
/// </li>
/// <li>
/// <p>To determine whether the node replacement is complete you can check Events using the Amazon ElastiCache console,
/// the Amazon CLI, or the ElastiCache API.
/// Look for the following automatic failover related events, listed here in order of occurrance:</p>
/// <ol>
/// <li>
/// <p>Replication group message: <code>Test Failover API called for node group <node-group-id></code>
/// </p>
/// </li>
/// <li>
/// <p>Cache cluster message: <code>Failover from primary node <primary-node-id> to replica node <node-id> completed</code>
/// </p>
/// </li>
/// <li>
/// <p>Replication group message: <code>Failover from primary node <primary-node-id> to replica node <node-id> completed</code>
/// </p>
/// </li>
/// <li>
/// <p>Cache cluster message: <code>Recovering cache nodes <node-id></code>
/// </p>
/// </li>
/// <li>
/// <p>Cache cluster message: <code>Finished recovery for cache nodes <node-id></code>
/// </p>
/// </li>
/// </ol>
/// <p>For more information see:</p>
/// <ul>
/// <li>
/// <p>
/// <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/ECEvents.Viewing.html">Viewing ElastiCache Events</a>
/// in the <i>ElastiCache User Guide</i>
/// </p>
/// </li>
/// <li>
/// <p>
/// <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/APIReference/API_DescribeEvents.html">DescribeEvents</a> in the ElastiCache API Reference</p>
/// </li>
/// </ul>
/// </li>
/// </ul>
/// <p>Also see, <a href="https://docs.aws.amazon.com/AmazonElastiCache/latest/red-ug/AutoFailover.html#auto-failover-test">Testing Multi-AZ </a> in the <i>ElastiCache User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct TestFailover {
    _private: (),
}
impl TestFailover {
    /// Creates a new builder-style object to manufacture [`TestFailoverInput`](crate::input::TestFailoverInput)
    pub fn builder() -> crate::input::test_failover_input::Builder {
        crate::input::test_failover_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for TestFailover {
    type Output =
        std::result::Result<crate::output::TestFailoverOutput, crate::error::TestFailoverError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_test_failover_error(response)
        } else {
            crate::operation_deser::parse_test_failover_response(response)
        }
    }
}
