// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[derive(Debug)]
pub(crate) struct Handle<
    C = smithy_client::erase::DynConnector,
    M = aws_hyper::AwsMiddleware,
    R = smithy_client::retry::Standard,
> {
    client: smithy_client::Client<C, M, R>,
    conf: crate::Config,
}

/// An ergonomic service client for `StarlingDoveService`.
///
/// This client allows ergonomic access to a `StarlingDoveService`-shaped service.
/// Each method corresponds to an endpoint defined in the service's Smithy model,
/// and the request and response shapes are auto-generated from that same model.
///
/// # Using a Client
///
/// Once you have a client set up, you can access the service's endpoints
/// by calling the appropriate method on [`Client`]. Each such method
/// returns a request builder for that endpoint, with methods for setting
/// the various fields of the request. Once your request is complete, use
/// the `send` method to send the request. `send` returns a future, which
/// you then have to `.await` to get the service's response.
///
/// [builder pattern]: https://rust-lang.github.io/api-guidelines/type-safety.html#c-builder
/// [SigV4-signed requests]: https://docs.aws.amazon.com/general/latest/gr/signature-version-4.html
#[derive(std::fmt::Debug)]
pub struct Client<
    C = smithy_client::erase::DynConnector,
    M = aws_hyper::AwsMiddleware,
    R = smithy_client::retry::Standard,
> {
    handle: std::sync::Arc<Handle<C, M, R>>,
}

impl<C, M, R> std::clone::Clone for Client<C, M, R> {
    fn clone(&self) -> Self {
        Self {
            handle: self.handle.clone(),
        }
    }
}

#[doc(inline)]
pub use smithy_client::Builder;

impl<C, M, R> From<smithy_client::Client<C, M, R>> for Client<C, M, R> {
    fn from(client: smithy_client::Client<C, M, R>) -> Self {
        Self::with_config(client, crate::Config::builder().build())
    }
}

impl<C, M, R> Client<C, M, R> {
    pub fn with_config(client: smithy_client::Client<C, M, R>, conf: crate::Config) -> Self {
        Self {
            handle: std::sync::Arc::new(Handle { client, conf }),
        }
    }

    pub fn conf(&self) -> &crate::Config {
        &self.handle.conf
    }
}
impl<C, M, R> Client<C, M, R>
where
    C: smithy_client::bounds::SmithyConnector,
    M: smithy_client::bounds::SmithyMiddleware<C>,
    R: smithy_client::retry::NewRequestPolicy,
{
    pub fn batch_get_aggregate_resource_config(
        &self,
    ) -> fluent_builders::BatchGetAggregateResourceConfig<C, M, R> {
        fluent_builders::BatchGetAggregateResourceConfig::new(self.handle.clone())
    }
    pub fn batch_get_resource_config(&self) -> fluent_builders::BatchGetResourceConfig<C, M, R> {
        fluent_builders::BatchGetResourceConfig::new(self.handle.clone())
    }
    pub fn delete_aggregation_authorization(
        &self,
    ) -> fluent_builders::DeleteAggregationAuthorization<C, M, R> {
        fluent_builders::DeleteAggregationAuthorization::new(self.handle.clone())
    }
    pub fn delete_config_rule(&self) -> fluent_builders::DeleteConfigRule<C, M, R> {
        fluent_builders::DeleteConfigRule::new(self.handle.clone())
    }
    pub fn delete_configuration_aggregator(
        &self,
    ) -> fluent_builders::DeleteConfigurationAggregator<C, M, R> {
        fluent_builders::DeleteConfigurationAggregator::new(self.handle.clone())
    }
    pub fn delete_configuration_recorder(
        &self,
    ) -> fluent_builders::DeleteConfigurationRecorder<C, M, R> {
        fluent_builders::DeleteConfigurationRecorder::new(self.handle.clone())
    }
    pub fn delete_conformance_pack(&self) -> fluent_builders::DeleteConformancePack<C, M, R> {
        fluent_builders::DeleteConformancePack::new(self.handle.clone())
    }
    pub fn delete_delivery_channel(&self) -> fluent_builders::DeleteDeliveryChannel<C, M, R> {
        fluent_builders::DeleteDeliveryChannel::new(self.handle.clone())
    }
    pub fn delete_evaluation_results(&self) -> fluent_builders::DeleteEvaluationResults<C, M, R> {
        fluent_builders::DeleteEvaluationResults::new(self.handle.clone())
    }
    pub fn delete_organization_config_rule(
        &self,
    ) -> fluent_builders::DeleteOrganizationConfigRule<C, M, R> {
        fluent_builders::DeleteOrganizationConfigRule::new(self.handle.clone())
    }
    pub fn delete_organization_conformance_pack(
        &self,
    ) -> fluent_builders::DeleteOrganizationConformancePack<C, M, R> {
        fluent_builders::DeleteOrganizationConformancePack::new(self.handle.clone())
    }
    pub fn delete_pending_aggregation_request(
        &self,
    ) -> fluent_builders::DeletePendingAggregationRequest<C, M, R> {
        fluent_builders::DeletePendingAggregationRequest::new(self.handle.clone())
    }
    pub fn delete_remediation_configuration(
        &self,
    ) -> fluent_builders::DeleteRemediationConfiguration<C, M, R> {
        fluent_builders::DeleteRemediationConfiguration::new(self.handle.clone())
    }
    pub fn delete_remediation_exceptions(
        &self,
    ) -> fluent_builders::DeleteRemediationExceptions<C, M, R> {
        fluent_builders::DeleteRemediationExceptions::new(self.handle.clone())
    }
    pub fn delete_resource_config(&self) -> fluent_builders::DeleteResourceConfig<C, M, R> {
        fluent_builders::DeleteResourceConfig::new(self.handle.clone())
    }
    pub fn delete_retention_configuration(
        &self,
    ) -> fluent_builders::DeleteRetentionConfiguration<C, M, R> {
        fluent_builders::DeleteRetentionConfiguration::new(self.handle.clone())
    }
    pub fn delete_stored_query(&self) -> fluent_builders::DeleteStoredQuery<C, M, R> {
        fluent_builders::DeleteStoredQuery::new(self.handle.clone())
    }
    pub fn deliver_config_snapshot(&self) -> fluent_builders::DeliverConfigSnapshot<C, M, R> {
        fluent_builders::DeliverConfigSnapshot::new(self.handle.clone())
    }
    pub fn describe_aggregate_compliance_by_config_rules(
        &self,
    ) -> fluent_builders::DescribeAggregateComplianceByConfigRules<C, M, R> {
        fluent_builders::DescribeAggregateComplianceByConfigRules::new(self.handle.clone())
    }
    pub fn describe_aggregate_compliance_by_conformance_packs(
        &self,
    ) -> fluent_builders::DescribeAggregateComplianceByConformancePacks<C, M, R> {
        fluent_builders::DescribeAggregateComplianceByConformancePacks::new(self.handle.clone())
    }
    pub fn describe_aggregation_authorizations(
        &self,
    ) -> fluent_builders::DescribeAggregationAuthorizations<C, M, R> {
        fluent_builders::DescribeAggregationAuthorizations::new(self.handle.clone())
    }
    pub fn describe_compliance_by_config_rule(
        &self,
    ) -> fluent_builders::DescribeComplianceByConfigRule<C, M, R> {
        fluent_builders::DescribeComplianceByConfigRule::new(self.handle.clone())
    }
    pub fn describe_compliance_by_resource(
        &self,
    ) -> fluent_builders::DescribeComplianceByResource<C, M, R> {
        fluent_builders::DescribeComplianceByResource::new(self.handle.clone())
    }
    pub fn describe_config_rule_evaluation_status(
        &self,
    ) -> fluent_builders::DescribeConfigRuleEvaluationStatus<C, M, R> {
        fluent_builders::DescribeConfigRuleEvaluationStatus::new(self.handle.clone())
    }
    pub fn describe_config_rules(&self) -> fluent_builders::DescribeConfigRules<C, M, R> {
        fluent_builders::DescribeConfigRules::new(self.handle.clone())
    }
    pub fn describe_configuration_aggregators(
        &self,
    ) -> fluent_builders::DescribeConfigurationAggregators<C, M, R> {
        fluent_builders::DescribeConfigurationAggregators::new(self.handle.clone())
    }
    pub fn describe_configuration_aggregator_sources_status(
        &self,
    ) -> fluent_builders::DescribeConfigurationAggregatorSourcesStatus<C, M, R> {
        fluent_builders::DescribeConfigurationAggregatorSourcesStatus::new(self.handle.clone())
    }
    pub fn describe_configuration_recorders(
        &self,
    ) -> fluent_builders::DescribeConfigurationRecorders<C, M, R> {
        fluent_builders::DescribeConfigurationRecorders::new(self.handle.clone())
    }
    pub fn describe_configuration_recorder_status(
        &self,
    ) -> fluent_builders::DescribeConfigurationRecorderStatus<C, M, R> {
        fluent_builders::DescribeConfigurationRecorderStatus::new(self.handle.clone())
    }
    pub fn describe_conformance_pack_compliance(
        &self,
    ) -> fluent_builders::DescribeConformancePackCompliance<C, M, R> {
        fluent_builders::DescribeConformancePackCompliance::new(self.handle.clone())
    }
    pub fn describe_conformance_packs(&self) -> fluent_builders::DescribeConformancePacks<C, M, R> {
        fluent_builders::DescribeConformancePacks::new(self.handle.clone())
    }
    pub fn describe_conformance_pack_status(
        &self,
    ) -> fluent_builders::DescribeConformancePackStatus<C, M, R> {
        fluent_builders::DescribeConformancePackStatus::new(self.handle.clone())
    }
    pub fn describe_delivery_channels(&self) -> fluent_builders::DescribeDeliveryChannels<C, M, R> {
        fluent_builders::DescribeDeliveryChannels::new(self.handle.clone())
    }
    pub fn describe_delivery_channel_status(
        &self,
    ) -> fluent_builders::DescribeDeliveryChannelStatus<C, M, R> {
        fluent_builders::DescribeDeliveryChannelStatus::new(self.handle.clone())
    }
    pub fn describe_organization_config_rules(
        &self,
    ) -> fluent_builders::DescribeOrganizationConfigRules<C, M, R> {
        fluent_builders::DescribeOrganizationConfigRules::new(self.handle.clone())
    }
    pub fn describe_organization_config_rule_statuses(
        &self,
    ) -> fluent_builders::DescribeOrganizationConfigRuleStatuses<C, M, R> {
        fluent_builders::DescribeOrganizationConfigRuleStatuses::new(self.handle.clone())
    }
    pub fn describe_organization_conformance_packs(
        &self,
    ) -> fluent_builders::DescribeOrganizationConformancePacks<C, M, R> {
        fluent_builders::DescribeOrganizationConformancePacks::new(self.handle.clone())
    }
    pub fn describe_organization_conformance_pack_statuses(
        &self,
    ) -> fluent_builders::DescribeOrganizationConformancePackStatuses<C, M, R> {
        fluent_builders::DescribeOrganizationConformancePackStatuses::new(self.handle.clone())
    }
    pub fn describe_pending_aggregation_requests(
        &self,
    ) -> fluent_builders::DescribePendingAggregationRequests<C, M, R> {
        fluent_builders::DescribePendingAggregationRequests::new(self.handle.clone())
    }
    pub fn describe_remediation_configurations(
        &self,
    ) -> fluent_builders::DescribeRemediationConfigurations<C, M, R> {
        fluent_builders::DescribeRemediationConfigurations::new(self.handle.clone())
    }
    pub fn describe_remediation_exceptions(
        &self,
    ) -> fluent_builders::DescribeRemediationExceptions<C, M, R> {
        fluent_builders::DescribeRemediationExceptions::new(self.handle.clone())
    }
    pub fn describe_remediation_execution_status(
        &self,
    ) -> fluent_builders::DescribeRemediationExecutionStatus<C, M, R> {
        fluent_builders::DescribeRemediationExecutionStatus::new(self.handle.clone())
    }
    pub fn describe_retention_configurations(
        &self,
    ) -> fluent_builders::DescribeRetentionConfigurations<C, M, R> {
        fluent_builders::DescribeRetentionConfigurations::new(self.handle.clone())
    }
    pub fn get_aggregate_compliance_details_by_config_rule(
        &self,
    ) -> fluent_builders::GetAggregateComplianceDetailsByConfigRule<C, M, R> {
        fluent_builders::GetAggregateComplianceDetailsByConfigRule::new(self.handle.clone())
    }
    pub fn get_aggregate_config_rule_compliance_summary(
        &self,
    ) -> fluent_builders::GetAggregateConfigRuleComplianceSummary<C, M, R> {
        fluent_builders::GetAggregateConfigRuleComplianceSummary::new(self.handle.clone())
    }
    pub fn get_aggregate_conformance_pack_compliance_summary(
        &self,
    ) -> fluent_builders::GetAggregateConformancePackComplianceSummary<C, M, R> {
        fluent_builders::GetAggregateConformancePackComplianceSummary::new(self.handle.clone())
    }
    pub fn get_aggregate_discovered_resource_counts(
        &self,
    ) -> fluent_builders::GetAggregateDiscoveredResourceCounts<C, M, R> {
        fluent_builders::GetAggregateDiscoveredResourceCounts::new(self.handle.clone())
    }
    pub fn get_aggregate_resource_config(
        &self,
    ) -> fluent_builders::GetAggregateResourceConfig<C, M, R> {
        fluent_builders::GetAggregateResourceConfig::new(self.handle.clone())
    }
    pub fn get_compliance_details_by_config_rule(
        &self,
    ) -> fluent_builders::GetComplianceDetailsByConfigRule<C, M, R> {
        fluent_builders::GetComplianceDetailsByConfigRule::new(self.handle.clone())
    }
    pub fn get_compliance_details_by_resource(
        &self,
    ) -> fluent_builders::GetComplianceDetailsByResource<C, M, R> {
        fluent_builders::GetComplianceDetailsByResource::new(self.handle.clone())
    }
    pub fn get_compliance_summary_by_config_rule(
        &self,
    ) -> fluent_builders::GetComplianceSummaryByConfigRule<C, M, R> {
        fluent_builders::GetComplianceSummaryByConfigRule::new(self.handle.clone())
    }
    pub fn get_compliance_summary_by_resource_type(
        &self,
    ) -> fluent_builders::GetComplianceSummaryByResourceType<C, M, R> {
        fluent_builders::GetComplianceSummaryByResourceType::new(self.handle.clone())
    }
    pub fn get_conformance_pack_compliance_details(
        &self,
    ) -> fluent_builders::GetConformancePackComplianceDetails<C, M, R> {
        fluent_builders::GetConformancePackComplianceDetails::new(self.handle.clone())
    }
    pub fn get_conformance_pack_compliance_summary(
        &self,
    ) -> fluent_builders::GetConformancePackComplianceSummary<C, M, R> {
        fluent_builders::GetConformancePackComplianceSummary::new(self.handle.clone())
    }
    pub fn get_discovered_resource_counts(
        &self,
    ) -> fluent_builders::GetDiscoveredResourceCounts<C, M, R> {
        fluent_builders::GetDiscoveredResourceCounts::new(self.handle.clone())
    }
    pub fn get_organization_config_rule_detailed_status(
        &self,
    ) -> fluent_builders::GetOrganizationConfigRuleDetailedStatus<C, M, R> {
        fluent_builders::GetOrganizationConfigRuleDetailedStatus::new(self.handle.clone())
    }
    pub fn get_organization_conformance_pack_detailed_status(
        &self,
    ) -> fluent_builders::GetOrganizationConformancePackDetailedStatus<C, M, R> {
        fluent_builders::GetOrganizationConformancePackDetailedStatus::new(self.handle.clone())
    }
    pub fn get_resource_config_history(
        &self,
    ) -> fluent_builders::GetResourceConfigHistory<C, M, R> {
        fluent_builders::GetResourceConfigHistory::new(self.handle.clone())
    }
    pub fn get_stored_query(&self) -> fluent_builders::GetStoredQuery<C, M, R> {
        fluent_builders::GetStoredQuery::new(self.handle.clone())
    }
    pub fn list_aggregate_discovered_resources(
        &self,
    ) -> fluent_builders::ListAggregateDiscoveredResources<C, M, R> {
        fluent_builders::ListAggregateDiscoveredResources::new(self.handle.clone())
    }
    pub fn list_discovered_resources(&self) -> fluent_builders::ListDiscoveredResources<C, M, R> {
        fluent_builders::ListDiscoveredResources::new(self.handle.clone())
    }
    pub fn list_stored_queries(&self) -> fluent_builders::ListStoredQueries<C, M, R> {
        fluent_builders::ListStoredQueries::new(self.handle.clone())
    }
    pub fn list_tags_for_resource(&self) -> fluent_builders::ListTagsForResource<C, M, R> {
        fluent_builders::ListTagsForResource::new(self.handle.clone())
    }
    pub fn put_aggregation_authorization(
        &self,
    ) -> fluent_builders::PutAggregationAuthorization<C, M, R> {
        fluent_builders::PutAggregationAuthorization::new(self.handle.clone())
    }
    pub fn put_config_rule(&self) -> fluent_builders::PutConfigRule<C, M, R> {
        fluent_builders::PutConfigRule::new(self.handle.clone())
    }
    pub fn put_configuration_aggregator(
        &self,
    ) -> fluent_builders::PutConfigurationAggregator<C, M, R> {
        fluent_builders::PutConfigurationAggregator::new(self.handle.clone())
    }
    pub fn put_configuration_recorder(&self) -> fluent_builders::PutConfigurationRecorder<C, M, R> {
        fluent_builders::PutConfigurationRecorder::new(self.handle.clone())
    }
    pub fn put_conformance_pack(&self) -> fluent_builders::PutConformancePack<C, M, R> {
        fluent_builders::PutConformancePack::new(self.handle.clone())
    }
    pub fn put_delivery_channel(&self) -> fluent_builders::PutDeliveryChannel<C, M, R> {
        fluent_builders::PutDeliveryChannel::new(self.handle.clone())
    }
    pub fn put_evaluations(&self) -> fluent_builders::PutEvaluations<C, M, R> {
        fluent_builders::PutEvaluations::new(self.handle.clone())
    }
    pub fn put_external_evaluation(&self) -> fluent_builders::PutExternalEvaluation<C, M, R> {
        fluent_builders::PutExternalEvaluation::new(self.handle.clone())
    }
    pub fn put_organization_config_rule(
        &self,
    ) -> fluent_builders::PutOrganizationConfigRule<C, M, R> {
        fluent_builders::PutOrganizationConfigRule::new(self.handle.clone())
    }
    pub fn put_organization_conformance_pack(
        &self,
    ) -> fluent_builders::PutOrganizationConformancePack<C, M, R> {
        fluent_builders::PutOrganizationConformancePack::new(self.handle.clone())
    }
    pub fn put_remediation_configurations(
        &self,
    ) -> fluent_builders::PutRemediationConfigurations<C, M, R> {
        fluent_builders::PutRemediationConfigurations::new(self.handle.clone())
    }
    pub fn put_remediation_exceptions(&self) -> fluent_builders::PutRemediationExceptions<C, M, R> {
        fluent_builders::PutRemediationExceptions::new(self.handle.clone())
    }
    pub fn put_resource_config(&self) -> fluent_builders::PutResourceConfig<C, M, R> {
        fluent_builders::PutResourceConfig::new(self.handle.clone())
    }
    pub fn put_retention_configuration(
        &self,
    ) -> fluent_builders::PutRetentionConfiguration<C, M, R> {
        fluent_builders::PutRetentionConfiguration::new(self.handle.clone())
    }
    pub fn put_stored_query(&self) -> fluent_builders::PutStoredQuery<C, M, R> {
        fluent_builders::PutStoredQuery::new(self.handle.clone())
    }
    pub fn select_aggregate_resource_config(
        &self,
    ) -> fluent_builders::SelectAggregateResourceConfig<C, M, R> {
        fluent_builders::SelectAggregateResourceConfig::new(self.handle.clone())
    }
    pub fn select_resource_config(&self) -> fluent_builders::SelectResourceConfig<C, M, R> {
        fluent_builders::SelectResourceConfig::new(self.handle.clone())
    }
    pub fn start_config_rules_evaluation(
        &self,
    ) -> fluent_builders::StartConfigRulesEvaluation<C, M, R> {
        fluent_builders::StartConfigRulesEvaluation::new(self.handle.clone())
    }
    pub fn start_configuration_recorder(
        &self,
    ) -> fluent_builders::StartConfigurationRecorder<C, M, R> {
        fluent_builders::StartConfigurationRecorder::new(self.handle.clone())
    }
    pub fn start_remediation_execution(
        &self,
    ) -> fluent_builders::StartRemediationExecution<C, M, R> {
        fluent_builders::StartRemediationExecution::new(self.handle.clone())
    }
    pub fn stop_configuration_recorder(
        &self,
    ) -> fluent_builders::StopConfigurationRecorder<C, M, R> {
        fluent_builders::StopConfigurationRecorder::new(self.handle.clone())
    }
    pub fn tag_resource(&self) -> fluent_builders::TagResource<C, M, R> {
        fluent_builders::TagResource::new(self.handle.clone())
    }
    pub fn untag_resource(&self) -> fluent_builders::UntagResource<C, M, R> {
        fluent_builders::UntagResource::new(self.handle.clone())
    }
}
pub mod fluent_builders {
    #[derive(std::fmt::Debug)]
    pub struct BatchGetAggregateResourceConfig<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::batch_get_aggregate_resource_config_input::Builder,
    }
    impl<C, M, R> BatchGetAggregateResourceConfig<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::BatchGetAggregateResourceConfigOutput,
            smithy_http::result::SdkError<crate::error::BatchGetAggregateResourceConfigError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::BatchGetAggregateResourceConfigInputOperationOutputAlias,
                crate::output::BatchGetAggregateResourceConfigOutput,
                crate::error::BatchGetAggregateResourceConfigError,
                crate::input::BatchGetAggregateResourceConfigInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(inp);
            self
        }
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// Appends an item to `ResourceIdentifiers`.
        ///
        /// To override the contents of this collection use [`set_resource_identifiers`](Self::set_resource_identifiers).
        /// <p>A list of aggregate ResourceIdentifiers objects. </p>
        pub fn resource_identifiers(
            mut self,
            inp: impl Into<crate::model::AggregateResourceIdentifier>,
        ) -> Self {
            self.inner = self.inner.resource_identifiers(inp);
            self
        }
        pub fn set_resource_identifiers(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::AggregateResourceIdentifier>>,
        ) -> Self {
            self.inner = self.inner.set_resource_identifiers(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct BatchGetResourceConfig<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::batch_get_resource_config_input::Builder,
    }
    impl<C, M, R> BatchGetResourceConfig<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::BatchGetResourceConfigOutput,
            smithy_http::result::SdkError<crate::error::BatchGetResourceConfigError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::BatchGetResourceConfigInputOperationOutputAlias,
                crate::output::BatchGetResourceConfigOutput,
                crate::error::BatchGetResourceConfigError,
                crate::input::BatchGetResourceConfigInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `resourceKeys`.
        ///
        /// To override the contents of this collection use [`set_resource_keys`](Self::set_resource_keys).
        /// <p>A list of resource keys to be processed with the current
        /// request. Each element in the list consists of the resource type and
        /// resource ID.</p>
        pub fn resource_keys(mut self, inp: impl Into<crate::model::ResourceKey>) -> Self {
            self.inner = self.inner.resource_keys(inp);
            self
        }
        pub fn set_resource_keys(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ResourceKey>>,
        ) -> Self {
            self.inner = self.inner.set_resource_keys(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteAggregationAuthorization<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::delete_aggregation_authorization_input::Builder,
    }
    impl<C, M, R> DeleteAggregationAuthorization<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteAggregationAuthorizationOutput,
            smithy_http::result::SdkError<crate::error::DeleteAggregationAuthorizationError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeleteAggregationAuthorizationInputOperationOutputAlias,
                crate::output::DeleteAggregationAuthorizationOutput,
                crate::error::DeleteAggregationAuthorizationError,
                crate::input::DeleteAggregationAuthorizationInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The 12-digit account ID of the account authorized to aggregate
        /// data.</p>
        pub fn authorized_account_id(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.authorized_account_id(inp);
            self
        }
        pub fn set_authorized_account_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_authorized_account_id(input);
            self
        }
        /// <p>The region authorized to collect aggregated data.</p>
        pub fn authorized_aws_region(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.authorized_aws_region(inp);
            self
        }
        pub fn set_authorized_aws_region(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_authorized_aws_region(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteConfigRule<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::delete_config_rule_input::Builder,
    }
    impl<C, M, R> DeleteConfigRule<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteConfigRuleOutput,
            smithy_http::result::SdkError<crate::error::DeleteConfigRuleError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeleteConfigRuleInputOperationOutputAlias,
                crate::output::DeleteConfigRuleOutput,
                crate::error::DeleteConfigRuleError,
                crate::input::DeleteConfigRuleInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the AWS Config rule that you want to
        /// delete.</p>
        pub fn config_rule_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(inp);
            self
        }
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteConfigurationAggregator<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::delete_configuration_aggregator_input::Builder,
    }
    impl<C, M, R> DeleteConfigurationAggregator<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteConfigurationAggregatorOutput,
            smithy_http::result::SdkError<crate::error::DeleteConfigurationAggregatorError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeleteConfigurationAggregatorInputOperationOutputAlias,
                crate::output::DeleteConfigurationAggregatorOutput,
                crate::error::DeleteConfigurationAggregatorError,
                crate::input::DeleteConfigurationAggregatorInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(inp);
            self
        }
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteConfigurationRecorder<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::delete_configuration_recorder_input::Builder,
    }
    impl<C, M, R> DeleteConfigurationRecorder<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteConfigurationRecorderOutput,
            smithy_http::result::SdkError<crate::error::DeleteConfigurationRecorderError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeleteConfigurationRecorderInputOperationOutputAlias,
                crate::output::DeleteConfigurationRecorderOutput,
                crate::error::DeleteConfigurationRecorderError,
                crate::input::DeleteConfigurationRecorderInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration recorder to be deleted. You can
        /// retrieve the name of your configuration recorder by using the
        /// <code>DescribeConfigurationRecorders</code> action.</p>
        pub fn configuration_recorder_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.configuration_recorder_name(inp);
            self
        }
        pub fn set_configuration_recorder_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_recorder_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteConformancePack<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::delete_conformance_pack_input::Builder,
    }
    impl<C, M, R> DeleteConformancePack<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteConformancePackOutput,
            smithy_http::result::SdkError<crate::error::DeleteConformancePackError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeleteConformancePackInputOperationOutputAlias,
                crate::output::DeleteConformancePackOutput,
                crate::error::DeleteConformancePackError,
                crate::input::DeleteConformancePackInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>Name of the conformance pack you want to delete.</p>
        pub fn conformance_pack_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.conformance_pack_name(inp);
            self
        }
        pub fn set_conformance_pack_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteDeliveryChannel<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::delete_delivery_channel_input::Builder,
    }
    impl<C, M, R> DeleteDeliveryChannel<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteDeliveryChannelOutput,
            smithy_http::result::SdkError<crate::error::DeleteDeliveryChannelError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeleteDeliveryChannelInputOperationOutputAlias,
                crate::output::DeleteDeliveryChannelOutput,
                crate::error::DeleteDeliveryChannelError,
                crate::input::DeleteDeliveryChannelInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the delivery channel to delete.</p>
        pub fn delivery_channel_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_channel_name(inp);
            self
        }
        pub fn set_delivery_channel_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_delivery_channel_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteEvaluationResults<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::delete_evaluation_results_input::Builder,
    }
    impl<C, M, R> DeleteEvaluationResults<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteEvaluationResultsOutput,
            smithy_http::result::SdkError<crate::error::DeleteEvaluationResultsError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeleteEvaluationResultsInputOperationOutputAlias,
                crate::output::DeleteEvaluationResultsOutput,
                crate::error::DeleteEvaluationResultsError,
                crate::input::DeleteEvaluationResultsInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the AWS Config rule for which you want to delete
        /// the evaluation results.</p>
        pub fn config_rule_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(inp);
            self
        }
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteOrganizationConfigRule<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::delete_organization_config_rule_input::Builder,
    }
    impl<C, M, R> DeleteOrganizationConfigRule<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteOrganizationConfigRuleOutput,
            smithy_http::result::SdkError<crate::error::DeleteOrganizationConfigRuleError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeleteOrganizationConfigRuleInputOperationOutputAlias,
                crate::output::DeleteOrganizationConfigRuleOutput,
                crate::error::DeleteOrganizationConfigRuleError,
                crate::input::DeleteOrganizationConfigRuleInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of organization config rule that you want to delete.</p>
        pub fn organization_config_rule_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_config_rule_name(inp);
            self
        }
        pub fn set_organization_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_organization_config_rule_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteOrganizationConformancePack<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::delete_organization_conformance_pack_input::Builder,
    }
    impl<C, M, R> DeleteOrganizationConformancePack<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteOrganizationConformancePackOutput,
            smithy_http::result::SdkError<crate::error::DeleteOrganizationConformancePackError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeleteOrganizationConformancePackInputOperationOutputAlias,
                crate::output::DeleteOrganizationConformancePackOutput,
                crate::error::DeleteOrganizationConformancePackError,
                crate::input::DeleteOrganizationConformancePackInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of organization conformance pack that you want to delete.</p>
        pub fn organization_conformance_pack_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_conformance_pack_name(inp);
            self
        }
        pub fn set_organization_conformance_pack_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_organization_conformance_pack_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeletePendingAggregationRequest<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::delete_pending_aggregation_request_input::Builder,
    }
    impl<C, M, R> DeletePendingAggregationRequest<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeletePendingAggregationRequestOutput,
            smithy_http::result::SdkError<crate::error::DeletePendingAggregationRequestError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeletePendingAggregationRequestInputOperationOutputAlias,
                crate::output::DeletePendingAggregationRequestOutput,
                crate::error::DeletePendingAggregationRequestError,
                crate::input::DeletePendingAggregationRequestInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The 12-digit account ID of the account requesting to aggregate
        /// data.</p>
        pub fn requester_account_id(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.requester_account_id(inp);
            self
        }
        pub fn set_requester_account_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_requester_account_id(input);
            self
        }
        /// <p>The region requesting to aggregate data.</p>
        pub fn requester_aws_region(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.requester_aws_region(inp);
            self
        }
        pub fn set_requester_aws_region(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_requester_aws_region(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteRemediationConfiguration<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::delete_remediation_configuration_input::Builder,
    }
    impl<C, M, R> DeleteRemediationConfiguration<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteRemediationConfigurationOutput,
            smithy_http::result::SdkError<crate::error::DeleteRemediationConfigurationError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeleteRemediationConfigurationInputOperationOutputAlias,
                crate::output::DeleteRemediationConfigurationOutput,
                crate::error::DeleteRemediationConfigurationError,
                crate::input::DeleteRemediationConfigurationInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the AWS Config rule for which you want to delete remediation configuration.</p>
        pub fn config_rule_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(inp);
            self
        }
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// <p>The type of a resource.</p>
        pub fn resource_type(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_type(inp);
            self
        }
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteRemediationExceptions<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::delete_remediation_exceptions_input::Builder,
    }
    impl<C, M, R> DeleteRemediationExceptions<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteRemediationExceptionsOutput,
            smithy_http::result::SdkError<crate::error::DeleteRemediationExceptionsError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeleteRemediationExceptionsInputOperationOutputAlias,
                crate::output::DeleteRemediationExceptionsOutput,
                crate::error::DeleteRemediationExceptionsError,
                crate::input::DeleteRemediationExceptionsInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the AWS Config rule for which you want to delete remediation exception configuration.</p>
        pub fn config_rule_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(inp);
            self
        }
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// Appends an item to `ResourceKeys`.
        ///
        /// To override the contents of this collection use [`set_resource_keys`](Self::set_resource_keys).
        /// <p>An exception list of resource exception keys to be processed with the current request. AWS Config adds exception for each resource key. For example, AWS Config adds 3 exceptions for 3 resource keys. </p>
        pub fn resource_keys(
            mut self,
            inp: impl Into<crate::model::RemediationExceptionResourceKey>,
        ) -> Self {
            self.inner = self.inner.resource_keys(inp);
            self
        }
        pub fn set_resource_keys(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::RemediationExceptionResourceKey>,
            >,
        ) -> Self {
            self.inner = self.inner.set_resource_keys(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteResourceConfig<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::delete_resource_config_input::Builder,
    }
    impl<C, M, R> DeleteResourceConfig<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteResourceConfigOutput,
            smithy_http::result::SdkError<crate::error::DeleteResourceConfigError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeleteResourceConfigInputOperationOutputAlias,
                crate::output::DeleteResourceConfigOutput,
                crate::error::DeleteResourceConfigError,
                crate::input::DeleteResourceConfigInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The type of the resource.</p>
        pub fn resource_type(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_type(inp);
            self
        }
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// <p>Unique identifier of the resource.</p>
        pub fn resource_id(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_id(inp);
            self
        }
        pub fn set_resource_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_id(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteRetentionConfiguration<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::delete_retention_configuration_input::Builder,
    }
    impl<C, M, R> DeleteRetentionConfiguration<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteRetentionConfigurationOutput,
            smithy_http::result::SdkError<crate::error::DeleteRetentionConfigurationError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeleteRetentionConfigurationInputOperationOutputAlias,
                crate::output::DeleteRetentionConfigurationOutput,
                crate::error::DeleteRetentionConfigurationError,
                crate::input::DeleteRetentionConfigurationInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the retention configuration to delete.</p>
        pub fn retention_configuration_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.retention_configuration_name(inp);
            self
        }
        pub fn set_retention_configuration_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_retention_configuration_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeleteStoredQuery<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::delete_stored_query_input::Builder,
    }
    impl<C, M, R> DeleteStoredQuery<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeleteStoredQueryOutput,
            smithy_http::result::SdkError<crate::error::DeleteStoredQueryError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeleteStoredQueryInputOperationOutputAlias,
                crate::output::DeleteStoredQueryOutput,
                crate::error::DeleteStoredQueryError,
                crate::input::DeleteStoredQueryInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the query that you want to delete.</p>
        pub fn query_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.query_name(inp);
            self
        }
        pub fn set_query_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_query_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DeliverConfigSnapshot<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::deliver_config_snapshot_input::Builder,
    }
    impl<C, M, R> DeliverConfigSnapshot<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DeliverConfigSnapshotOutput,
            smithy_http::result::SdkError<crate::error::DeliverConfigSnapshotError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DeliverConfigSnapshotInputOperationOutputAlias,
                crate::output::DeliverConfigSnapshotOutput,
                crate::error::DeliverConfigSnapshotError,
                crate::input::DeliverConfigSnapshotInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the delivery channel through which the snapshot is
        /// delivered.</p>
        pub fn delivery_channel_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_channel_name(inp);
            self
        }
        pub fn set_delivery_channel_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_delivery_channel_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeAggregateComplianceByConfigRules<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_aggregate_compliance_by_config_rules_input::Builder,
    }
    impl<C, M, R> DescribeAggregateComplianceByConfigRules<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeAggregateComplianceByConfigRulesOutput,
            smithy_http::result::SdkError<
                crate::error::DescribeAggregateComplianceByConfigRulesError,
            >,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeAggregateComplianceByConfigRulesInputOperationOutputAlias,
                crate::output::DescribeAggregateComplianceByConfigRulesOutput,
                crate::error::DescribeAggregateComplianceByConfigRulesError,
                crate::input::DescribeAggregateComplianceByConfigRulesInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(inp);
            self
        }
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>Filters the results by ConfigRuleComplianceFilters object.
        /// </p>
        pub fn filters(mut self, inp: crate::model::ConfigRuleComplianceFilters) -> Self {
            self.inner = self.inner.filters(inp);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::ConfigRuleComplianceFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page.
        /// The default is
        /// maximum.
        /// If you specify 0, AWS Config uses the default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use
        /// to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeAggregateComplianceByConformancePacks<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_aggregate_compliance_by_conformance_packs_input::Builder,
    }
    impl<C, M, R> DescribeAggregateComplianceByConformancePacks<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
                                pub async fn send(self) -> std::result::Result<crate::output::DescribeAggregateComplianceByConformancePacksOutput, smithy_http::result::SdkError<crate::error::DescribeAggregateComplianceByConformancePacksError>>
                                where
                                    R::Policy: smithy_client::bounds::SmithyRetryPolicy<crate::input::DescribeAggregateComplianceByConformancePacksInputOperationOutputAlias,
                                    crate::output::DescribeAggregateComplianceByConformancePacksOutput,
                                    crate::error::DescribeAggregateComplianceByConformancePacksError,
                                    crate::input::DescribeAggregateComplianceByConformancePacksInputOperationRetryAlias>,
                                {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(inp);
            self
        }
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>Filters the result by <code>AggregateConformancePackComplianceFilters</code> object.</p>
        pub fn filters(
            mut self,
            inp: crate::model::AggregateConformancePackComplianceFilters,
        ) -> Self {
            self.inner = self.inner.filters(inp);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::AggregateConformancePackComplianceFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The maximum number of conformance packs compliance details returned on each page. The default is maximum. If you specify 0, AWS Config uses the default. </p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeAggregationAuthorizations<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_aggregation_authorizations_input::Builder,
    }
    impl<C, M, R> DescribeAggregationAuthorizations<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeAggregationAuthorizationsOutput,
            smithy_http::result::SdkError<crate::error::DescribeAggregationAuthorizationsError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeAggregationAuthorizationsInputOperationOutputAlias,
                crate::output::DescribeAggregationAuthorizationsOutput,
                crate::error::DescribeAggregationAuthorizationsError,
                crate::input::DescribeAggregationAuthorizationsInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The maximum number of AggregationAuthorizations returned on
        /// each page. The default is maximum. If you specify 0, AWS Config uses
        /// the default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use
        /// to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeComplianceByConfigRule<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_compliance_by_config_rule_input::Builder,
    }
    impl<C, M, R> DescribeComplianceByConfigRule<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeComplianceByConfigRuleOutput,
            smithy_http::result::SdkError<crate::error::DescribeComplianceByConfigRuleError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeComplianceByConfigRuleInputOperationOutputAlias,
                crate::output::DescribeComplianceByConfigRuleOutput,
                crate::error::DescribeComplianceByConfigRuleError,
                crate::input::DescribeComplianceByConfigRuleInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ConfigRuleNames`.
        ///
        /// To override the contents of this collection use [`set_config_rule_names`](Self::set_config_rule_names).
        /// <p>Specify one or more AWS Config rule names to filter the results
        /// by rule.</p>
        pub fn config_rule_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_names(inp);
            self
        }
        pub fn set_config_rule_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_names(input);
            self
        }
        /// Appends an item to `ComplianceTypes`.
        ///
        /// To override the contents of this collection use [`set_compliance_types`](Self::set_compliance_types).
        /// <p>Filters the results by compliance.</p>
        /// <p>The allowed values are <code>COMPLIANT</code> and <code>NON_COMPLIANT</code>.</p>
        pub fn compliance_types(mut self, inp: impl Into<crate::model::ComplianceType>) -> Self {
            self.inner = self.inner.compliance_types(inp);
            self
        }
        pub fn set_compliance_types(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ComplianceType>>,
        ) -> Self {
            self.inner = self.inner.set_compliance_types(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page
        /// that you use to get the next page of results in a paginated
        /// response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeComplianceByResource<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_compliance_by_resource_input::Builder,
    }
    impl<C, M, R> DescribeComplianceByResource<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeComplianceByResourceOutput,
            smithy_http::result::SdkError<crate::error::DescribeComplianceByResourceError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeComplianceByResourceInputOperationOutputAlias,
                crate::output::DescribeComplianceByResourceOutput,
                crate::error::DescribeComplianceByResourceError,
                crate::input::DescribeComplianceByResourceInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The types of AWS resources for which you want compliance
        /// information (for example, <code>AWS::EC2::Instance</code>). For this
        /// action, you can specify that the resource type is an AWS account by
        /// specifying <code>AWS::::Account</code>.</p>
        pub fn resource_type(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_type(inp);
            self
        }
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// <p>The ID of the AWS resource for which you want compliance
        /// information. You can specify only one resource ID. If you specify a
        /// resource ID, you must also specify a type for
        /// <code>ResourceType</code>.</p>
        pub fn resource_id(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_id(inp);
            self
        }
        pub fn set_resource_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_id(input);
            self
        }
        /// Appends an item to `ComplianceTypes`.
        ///
        /// To override the contents of this collection use [`set_compliance_types`](Self::set_compliance_types).
        /// <p>Filters the results by compliance.</p>
        /// <p>The allowed values are <code>COMPLIANT</code>, <code>NON_COMPLIANT</code>, and <code>INSUFFICIENT_DATA</code>.</p>
        pub fn compliance_types(mut self, inp: impl Into<crate::model::ComplianceType>) -> Self {
            self.inner = self.inner.compliance_types(inp);
            self
        }
        pub fn set_compliance_types(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ComplianceType>>,
        ) -> Self {
            self.inner = self.inner.set_compliance_types(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page.
        /// The default is 10. You cannot specify a number greater than 100. If
        /// you specify 0, AWS Config uses the default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page
        /// that you use to get the next page of results in a paginated
        /// response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeConfigRuleEvaluationStatus<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_config_rule_evaluation_status_input::Builder,
    }
    impl<C, M, R> DescribeConfigRuleEvaluationStatus<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConfigRuleEvaluationStatusOutput,
            smithy_http::result::SdkError<crate::error::DescribeConfigRuleEvaluationStatusError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeConfigRuleEvaluationStatusInputOperationOutputAlias,
                crate::output::DescribeConfigRuleEvaluationStatusOutput,
                crate::error::DescribeConfigRuleEvaluationStatusError,
                crate::input::DescribeConfigRuleEvaluationStatusInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ConfigRuleNames`.
        ///
        /// To override the contents of this collection use [`set_config_rule_names`](Self::set_config_rule_names).
        /// <p>The name of the AWS managed Config rules for which you want
        /// status information. If you do not specify any names, AWS Config
        /// returns status information for all AWS managed Config rules that you
        /// use.</p>
        pub fn config_rule_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_names(inp);
            self
        }
        pub fn set_config_rule_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_names(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page
        /// that you use to get the next page of results in a paginated
        /// response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The number of rule evaluation results that you want
        /// returned.</p>
        /// <p>This parameter is required if the rule limit for your account
        /// is more than the default of 150 rules.</p>
        /// <p>For information about requesting a rule limit increase, see
        /// <a href="http://docs.aws.amazon.com/general/latest/gr/aws_service_limits.html#limits_config">AWS Config Limits</a> in the <i>AWS General
        /// Reference Guide</i>.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeConfigRules<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_config_rules_input::Builder,
    }
    impl<C, M, R> DescribeConfigRules<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConfigRulesOutput,
            smithy_http::result::SdkError<crate::error::DescribeConfigRulesError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeConfigRulesInputOperationOutputAlias,
                crate::output::DescribeConfigRulesOutput,
                crate::error::DescribeConfigRulesError,
                crate::input::DescribeConfigRulesInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ConfigRuleNames`.
        ///
        /// To override the contents of this collection use [`set_config_rule_names`](Self::set_config_rule_names).
        /// <p>The names of the AWS Config rules for which you want details.
        /// If you do not specify any names, AWS Config returns details for all
        /// your rules.</p>
        pub fn config_rule_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_names(inp);
            self
        }
        pub fn set_config_rule_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_names(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page
        /// that you use to get the next page of results in a paginated
        /// response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeConfigurationAggregators<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_configuration_aggregators_input::Builder,
    }
    impl<C, M, R> DescribeConfigurationAggregators<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConfigurationAggregatorsOutput,
            smithy_http::result::SdkError<crate::error::DescribeConfigurationAggregatorsError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeConfigurationAggregatorsInputOperationOutputAlias,
                crate::output::DescribeConfigurationAggregatorsOutput,
                crate::error::DescribeConfigurationAggregatorsError,
                crate::input::DescribeConfigurationAggregatorsInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ConfigurationAggregatorNames`.
        ///
        /// To override the contents of this collection use [`set_configuration_aggregator_names`](Self::set_configuration_aggregator_names).
        /// <p>The name of the configuration aggregators.</p>
        pub fn configuration_aggregator_names(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_names(inp);
            self
        }
        pub fn set_configuration_aggregator_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_names(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use
        /// to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of configuration aggregators returned on
        /// each page. The default is maximum. If you specify 0, AWS Config uses
        /// the default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeConfigurationAggregatorSourcesStatus<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_configuration_aggregator_sources_status_input::Builder,
    }
    impl<C, M, R> DescribeConfigurationAggregatorSourcesStatus<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConfigurationAggregatorSourcesStatusOutput,
            smithy_http::result::SdkError<
                crate::error::DescribeConfigurationAggregatorSourcesStatusError,
            >,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeConfigurationAggregatorSourcesStatusInputOperationOutputAlias,
                crate::output::DescribeConfigurationAggregatorSourcesStatusOutput,
                crate::error::DescribeConfigurationAggregatorSourcesStatusError,
                crate::input::DescribeConfigurationAggregatorSourcesStatusInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(inp);
            self
        }
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// Appends an item to `UpdateStatus`.
        ///
        /// To override the contents of this collection use [`set_update_status`](Self::set_update_status).
        /// <p>Filters the status type.</p>
        /// <ul>
        /// <li>
        /// <p>Valid value FAILED indicates errors while moving
        /// data.</p>
        /// </li>
        /// <li>
        /// <p>Valid value SUCCEEDED indicates the data was
        /// successfully moved.</p>
        /// </li>
        /// <li>
        /// <p>Valid value OUTDATED indicates the data is not the most
        /// recent.</p>
        /// </li>
        /// </ul>
        pub fn update_status(
            mut self,
            inp: impl Into<crate::model::AggregatedSourceStatusType>,
        ) -> Self {
            self.inner = self.inner.update_status(inp);
            self
        }
        pub fn set_update_status(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::AggregatedSourceStatusType>>,
        ) -> Self {
            self.inner = self.inner.set_update_status(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use
        /// to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of AggregatorSourceStatus returned on each
        /// page. The default is maximum. If you specify 0, AWS Config uses the
        /// default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeConfigurationRecorders<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_configuration_recorders_input::Builder,
    }
    impl<C, M, R> DescribeConfigurationRecorders<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConfigurationRecordersOutput,
            smithy_http::result::SdkError<crate::error::DescribeConfigurationRecordersError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeConfigurationRecordersInputOperationOutputAlias,
                crate::output::DescribeConfigurationRecordersOutput,
                crate::error::DescribeConfigurationRecordersError,
                crate::input::DescribeConfigurationRecordersInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ConfigurationRecorderNames`.
        ///
        /// To override the contents of this collection use [`set_configuration_recorder_names`](Self::set_configuration_recorder_names).
        /// <p>A list of configuration recorder names.</p>
        pub fn configuration_recorder_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.configuration_recorder_names(inp);
            self
        }
        pub fn set_configuration_recorder_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_configuration_recorder_names(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeConfigurationRecorderStatus<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_configuration_recorder_status_input::Builder,
    }
    impl<C, M, R> DescribeConfigurationRecorderStatus<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConfigurationRecorderStatusOutput,
            smithy_http::result::SdkError<crate::error::DescribeConfigurationRecorderStatusError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeConfigurationRecorderStatusInputOperationOutputAlias,
                crate::output::DescribeConfigurationRecorderStatusOutput,
                crate::error::DescribeConfigurationRecorderStatusError,
                crate::input::DescribeConfigurationRecorderStatusInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ConfigurationRecorderNames`.
        ///
        /// To override the contents of this collection use [`set_configuration_recorder_names`](Self::set_configuration_recorder_names).
        /// <p>The name(s) of the configuration recorder. If the name is not
        /// specified, the action returns the current status of all the
        /// configuration recorders associated with the account.</p>
        pub fn configuration_recorder_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.configuration_recorder_names(inp);
            self
        }
        pub fn set_configuration_recorder_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_configuration_recorder_names(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeConformancePackCompliance<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_conformance_pack_compliance_input::Builder,
    }
    impl<C, M, R> DescribeConformancePackCompliance<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConformancePackComplianceOutput,
            smithy_http::result::SdkError<crate::error::DescribeConformancePackComplianceError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeConformancePackComplianceInputOperationOutputAlias,
                crate::output::DescribeConformancePackComplianceOutput,
                crate::error::DescribeConformancePackComplianceError,
                crate::input::DescribeConformancePackComplianceInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>Name of the conformance pack.</p>
        pub fn conformance_pack_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.conformance_pack_name(inp);
            self
        }
        pub fn set_conformance_pack_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_name(input);
            self
        }
        /// <p>A <code>ConformancePackComplianceFilters</code> object.</p>
        pub fn filters(mut self, inp: crate::model::ConformancePackComplianceFilters) -> Self {
            self.inner = self.inner.filters(inp);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::ConformancePackComplianceFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The maximum number of AWS Config rules within a conformance pack are returned on each page.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeConformancePacks<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_conformance_packs_input::Builder,
    }
    impl<C, M, R> DescribeConformancePacks<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConformancePacksOutput,
            smithy_http::result::SdkError<crate::error::DescribeConformancePacksError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeConformancePacksInputOperationOutputAlias,
                crate::output::DescribeConformancePacksOutput,
                crate::error::DescribeConformancePacksError,
                crate::input::DescribeConformancePacksInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ConformancePackNames`.
        ///
        /// To override the contents of this collection use [`set_conformance_pack_names`](Self::set_conformance_pack_names).
        /// <p>Comma-separated list of conformance pack names for which you want details. If you do not specify any names, AWS Config returns details for all your conformance packs. </p>
        pub fn conformance_pack_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.conformance_pack_names(inp);
            self
        }
        pub fn set_conformance_pack_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_names(input);
            self
        }
        /// <p>The maximum number of conformance packs returned on each page.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeConformancePackStatus<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_conformance_pack_status_input::Builder,
    }
    impl<C, M, R> DescribeConformancePackStatus<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeConformancePackStatusOutput,
            smithy_http::result::SdkError<crate::error::DescribeConformancePackStatusError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeConformancePackStatusInputOperationOutputAlias,
                crate::output::DescribeConformancePackStatusOutput,
                crate::error::DescribeConformancePackStatusError,
                crate::input::DescribeConformancePackStatusInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ConformancePackNames`.
        ///
        /// To override the contents of this collection use [`set_conformance_pack_names`](Self::set_conformance_pack_names).
        /// <p>Comma-separated list of conformance pack names.</p>
        pub fn conformance_pack_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.conformance_pack_names(inp);
            self
        }
        pub fn set_conformance_pack_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_names(input);
            self
        }
        /// <p>The maximum number of conformance packs status returned on each page.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeDeliveryChannels<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_delivery_channels_input::Builder,
    }
    impl<C, M, R> DescribeDeliveryChannels<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeDeliveryChannelsOutput,
            smithy_http::result::SdkError<crate::error::DescribeDeliveryChannelsError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeDeliveryChannelsInputOperationOutputAlias,
                crate::output::DescribeDeliveryChannelsOutput,
                crate::error::DescribeDeliveryChannelsError,
                crate::input::DescribeDeliveryChannelsInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `DeliveryChannelNames`.
        ///
        /// To override the contents of this collection use [`set_delivery_channel_names`](Self::set_delivery_channel_names).
        /// <p>A list of delivery channel names.</p>
        pub fn delivery_channel_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_channel_names(inp);
            self
        }
        pub fn set_delivery_channel_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_delivery_channel_names(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeDeliveryChannelStatus<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_delivery_channel_status_input::Builder,
    }
    impl<C, M, R> DescribeDeliveryChannelStatus<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeDeliveryChannelStatusOutput,
            smithy_http::result::SdkError<crate::error::DescribeDeliveryChannelStatusError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeDeliveryChannelStatusInputOperationOutputAlias,
                crate::output::DescribeDeliveryChannelStatusOutput,
                crate::error::DescribeDeliveryChannelStatusError,
                crate::input::DescribeDeliveryChannelStatusInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `DeliveryChannelNames`.
        ///
        /// To override the contents of this collection use [`set_delivery_channel_names`](Self::set_delivery_channel_names).
        /// <p>A list of delivery channel names.</p>
        pub fn delivery_channel_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_channel_names(inp);
            self
        }
        pub fn set_delivery_channel_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_delivery_channel_names(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeOrganizationConfigRules<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_organization_config_rules_input::Builder,
    }
    impl<C, M, R> DescribeOrganizationConfigRules<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeOrganizationConfigRulesOutput,
            smithy_http::result::SdkError<crate::error::DescribeOrganizationConfigRulesError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeOrganizationConfigRulesInputOperationOutputAlias,
                crate::output::DescribeOrganizationConfigRulesOutput,
                crate::error::DescribeOrganizationConfigRulesError,
                crate::input::DescribeOrganizationConfigRulesInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `OrganizationConfigRuleNames`.
        ///
        /// To override the contents of this collection use [`set_organization_config_rule_names`](Self::set_organization_config_rule_names).
        /// <p>The names of organization config rules for which you want details. If you do not specify any names, AWS Config returns details for all your organization config rules.</p>
        pub fn organization_config_rule_names(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_config_rule_names(inp);
            self
        }
        pub fn set_organization_config_rule_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_organization_config_rule_names(input);
            self
        }
        /// <p>The maximum number of organization config rules returned on each page. If you do no specify a number, AWS Config uses the default. The default is 100.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeOrganizationConfigRuleStatuses<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_organization_config_rule_statuses_input::Builder,
    }
    impl<C, M, R> DescribeOrganizationConfigRuleStatuses<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeOrganizationConfigRuleStatusesOutput,
            smithy_http::result::SdkError<
                crate::error::DescribeOrganizationConfigRuleStatusesError,
            >,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeOrganizationConfigRuleStatusesInputOperationOutputAlias,
                crate::output::DescribeOrganizationConfigRuleStatusesOutput,
                crate::error::DescribeOrganizationConfigRuleStatusesError,
                crate::input::DescribeOrganizationConfigRuleStatusesInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `OrganizationConfigRuleNames`.
        ///
        /// To override the contents of this collection use [`set_organization_config_rule_names`](Self::set_organization_config_rule_names).
        /// <p>The names of organization config rules for which you want status details. If you do not specify any names, AWS Config returns details for all your organization AWS Confg rules.</p>
        pub fn organization_config_rule_names(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_config_rule_names(inp);
            self
        }
        pub fn set_organization_config_rule_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_organization_config_rule_names(input);
            self
        }
        /// <p>The maximum number of <code>OrganizationConfigRuleStatuses</code> returned on each page. If you do no specify a number, AWS Config uses the default. The default is 100.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeOrganizationConformancePacks<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_organization_conformance_packs_input::Builder,
    }
    impl<C, M, R> DescribeOrganizationConformancePacks<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeOrganizationConformancePacksOutput,
            smithy_http::result::SdkError<crate::error::DescribeOrganizationConformancePacksError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeOrganizationConformancePacksInputOperationOutputAlias,
                crate::output::DescribeOrganizationConformancePacksOutput,
                crate::error::DescribeOrganizationConformancePacksError,
                crate::input::DescribeOrganizationConformancePacksInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `OrganizationConformancePackNames`.
        ///
        /// To override the contents of this collection use [`set_organization_conformance_pack_names`](Self::set_organization_conformance_pack_names).
        /// <p>The name that you assign to an organization conformance pack.</p>
        pub fn organization_conformance_pack_names(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_conformance_pack_names(inp);
            self
        }
        pub fn set_organization_conformance_pack_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_organization_conformance_pack_names(input);
            self
        }
        /// <p>The maximum number of organization config packs returned on each page. If you do no specify a
        /// number, AWS Config uses the default. The default is 100.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The nextToken string returned on a previous page that you use to get the next page of results in a
        /// paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeOrganizationConformancePackStatuses<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_organization_conformance_pack_statuses_input::Builder,
    }
    impl<C, M, R> DescribeOrganizationConformancePackStatuses<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeOrganizationConformancePackStatusesOutput,
            smithy_http::result::SdkError<
                crate::error::DescribeOrganizationConformancePackStatusesError,
            >,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeOrganizationConformancePackStatusesInputOperationOutputAlias,
                crate::output::DescribeOrganizationConformancePackStatusesOutput,
                crate::error::DescribeOrganizationConformancePackStatusesError,
                crate::input::DescribeOrganizationConformancePackStatusesInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `OrganizationConformancePackNames`.
        ///
        /// To override the contents of this collection use [`set_organization_conformance_pack_names`](Self::set_organization_conformance_pack_names).
        /// <p>The names of organization conformance packs for which you want status details.
        /// If you do not specify any names, AWS Config returns details for all your organization conformance packs. </p>
        pub fn organization_conformance_pack_names(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_conformance_pack_names(inp);
            self
        }
        pub fn set_organization_conformance_pack_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_organization_conformance_pack_names(input);
            self
        }
        /// <p>The maximum number of OrganizationConformancePackStatuses returned on each page.
        /// If you do no specify a number, AWS Config uses the default. The default is 100. </p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribePendingAggregationRequests<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_pending_aggregation_requests_input::Builder,
    }
    impl<C, M, R> DescribePendingAggregationRequests<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribePendingAggregationRequestsOutput,
            smithy_http::result::SdkError<crate::error::DescribePendingAggregationRequestsError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribePendingAggregationRequestsInputOperationOutputAlias,
                crate::output::DescribePendingAggregationRequestsOutput,
                crate::error::DescribePendingAggregationRequestsError,
                crate::input::DescribePendingAggregationRequestsInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The maximum number of evaluation results returned on each page.
        /// The default is maximum. If you specify 0, AWS Config uses the
        /// default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use
        /// to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeRemediationConfigurations<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_remediation_configurations_input::Builder,
    }
    impl<C, M, R> DescribeRemediationConfigurations<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeRemediationConfigurationsOutput,
            smithy_http::result::SdkError<crate::error::DescribeRemediationConfigurationsError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeRemediationConfigurationsInputOperationOutputAlias,
                crate::output::DescribeRemediationConfigurationsOutput,
                crate::error::DescribeRemediationConfigurationsError,
                crate::input::DescribeRemediationConfigurationsInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ConfigRuleNames`.
        ///
        /// To override the contents of this collection use [`set_config_rule_names`](Self::set_config_rule_names).
        /// <p>A list of AWS Config rule names of remediation configurations for which you want details. </p>
        pub fn config_rule_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_names(inp);
            self
        }
        pub fn set_config_rule_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_names(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeRemediationExceptions<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_remediation_exceptions_input::Builder,
    }
    impl<C, M, R> DescribeRemediationExceptions<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeRemediationExceptionsOutput,
            smithy_http::result::SdkError<crate::error::DescribeRemediationExceptionsError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeRemediationExceptionsInputOperationOutputAlias,
                crate::output::DescribeRemediationExceptionsOutput,
                crate::error::DescribeRemediationExceptionsError,
                crate::input::DescribeRemediationExceptionsInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the AWS Config rule.</p>
        pub fn config_rule_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(inp);
            self
        }
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// Appends an item to `ResourceKeys`.
        ///
        /// To override the contents of this collection use [`set_resource_keys`](Self::set_resource_keys).
        /// <p>An exception list of resource exception keys to be processed with the current request. AWS Config adds exception for each resource key. For example, AWS Config adds 3 exceptions for 3 resource keys. </p>
        pub fn resource_keys(
            mut self,
            inp: impl Into<crate::model::RemediationExceptionResourceKey>,
        ) -> Self {
            self.inner = self.inner.resource_keys(inp);
            self
        }
        pub fn set_resource_keys(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::RemediationExceptionResourceKey>,
            >,
        ) -> Self {
            self.inner = self.inner.set_resource_keys(input);
            self
        }
        /// <p>The maximum number of RemediationExceptionResourceKey returned on each page. The default is 25. If you specify 0, AWS Config uses the default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeRemediationExecutionStatus<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_remediation_execution_status_input::Builder,
    }
    impl<C, M, R> DescribeRemediationExecutionStatus<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeRemediationExecutionStatusOutput,
            smithy_http::result::SdkError<crate::error::DescribeRemediationExecutionStatusError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeRemediationExecutionStatusInputOperationOutputAlias,
                crate::output::DescribeRemediationExecutionStatusOutput,
                crate::error::DescribeRemediationExecutionStatusError,
                crate::input::DescribeRemediationExecutionStatusInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>A list of AWS Config rule names.</p>
        pub fn config_rule_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(inp);
            self
        }
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// Appends an item to `ResourceKeys`.
        ///
        /// To override the contents of this collection use [`set_resource_keys`](Self::set_resource_keys).
        /// <p>A list of resource keys to be processed with the current request. Each element in the list consists of the resource type and resource ID. </p>
        pub fn resource_keys(mut self, inp: impl Into<crate::model::ResourceKey>) -> Self {
            self.inner = self.inner.resource_keys(inp);
            self
        }
        pub fn set_resource_keys(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ResourceKey>>,
        ) -> Self {
            self.inner = self.inner.set_resource_keys(input);
            self
        }
        /// <p>The maximum number of RemediationExecutionStatuses returned on each page. The default is maximum. If you specify 0, AWS Config uses the default. </p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct DescribeRetentionConfigurations<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::describe_retention_configurations_input::Builder,
    }
    impl<C, M, R> DescribeRetentionConfigurations<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::DescribeRetentionConfigurationsOutput,
            smithy_http::result::SdkError<crate::error::DescribeRetentionConfigurationsError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::DescribeRetentionConfigurationsInputOperationOutputAlias,
                crate::output::DescribeRetentionConfigurationsOutput,
                crate::error::DescribeRetentionConfigurationsError,
                crate::input::DescribeRetentionConfigurationsInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `RetentionConfigurationNames`.
        ///
        /// To override the contents of this collection use [`set_retention_configuration_names`](Self::set_retention_configuration_names).
        /// <p>A list of names of retention configurations for which you want
        /// details. If you do not specify a name, AWS Config returns details
        /// for all the retention configurations for that account.</p>
        /// <note>
        /// <p>Currently, AWS Config supports only one retention
        /// configuration per region in your account.</p>
        /// </note>
        pub fn retention_configuration_names(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.retention_configuration_names(inp);
            self
        }
        pub fn set_retention_configuration_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_retention_configuration_names(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page
        /// that you use to get the next page of results in a paginated
        /// response. </p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetAggregateComplianceDetailsByConfigRule<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_aggregate_compliance_details_by_config_rule_input::Builder,
    }
    impl<C, M, R> GetAggregateComplianceDetailsByConfigRule<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetAggregateComplianceDetailsByConfigRuleOutput,
            smithy_http::result::SdkError<
                crate::error::GetAggregateComplianceDetailsByConfigRuleError,
            >,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetAggregateComplianceDetailsByConfigRuleInputOperationOutputAlias,
                crate::output::GetAggregateComplianceDetailsByConfigRuleOutput,
                crate::error::GetAggregateComplianceDetailsByConfigRuleError,
                crate::input::GetAggregateComplianceDetailsByConfigRuleInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(inp);
            self
        }
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>The name of the AWS Config rule for which you want compliance
        /// information.</p>
        pub fn config_rule_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(inp);
            self
        }
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// <p>The 12-digit account ID of the source account.</p>
        pub fn account_id(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.account_id(inp);
            self
        }
        pub fn set_account_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_account_id(input);
            self
        }
        /// <p>The source region from where the data is aggregated.</p>
        pub fn aws_region(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.aws_region(inp);
            self
        }
        pub fn set_aws_region(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_aws_region(input);
            self
        }
        /// <p>The resource compliance status.</p>
        /// <note>
        /// <p>For the
        /// <code>GetAggregateComplianceDetailsByConfigRuleRequest</code>
        /// data type, AWS Config supports only the <code>COMPLIANT</code>
        /// and <code>NON_COMPLIANT</code>. AWS Config does not support the
        /// <code>NOT_APPLICABLE</code> and
        /// <code>INSUFFICIENT_DATA</code> values.</p>
        /// </note>
        pub fn compliance_type(mut self, inp: crate::model::ComplianceType) -> Self {
            self.inner = self.inner.compliance_type(inp);
            self
        }
        pub fn set_compliance_type(
            mut self,
            input: std::option::Option<crate::model::ComplianceType>,
        ) -> Self {
            self.inner = self.inner.set_compliance_type(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page.
        /// The default is 50. You cannot specify a number greater than 100. If
        /// you specify 0, AWS Config uses the default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use
        /// to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetAggregateConfigRuleComplianceSummary<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_aggregate_config_rule_compliance_summary_input::Builder,
    }
    impl<C, M, R> GetAggregateConfigRuleComplianceSummary<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetAggregateConfigRuleComplianceSummaryOutput,
            smithy_http::result::SdkError<
                crate::error::GetAggregateConfigRuleComplianceSummaryError,
            >,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetAggregateConfigRuleComplianceSummaryInputOperationOutputAlias,
                crate::output::GetAggregateConfigRuleComplianceSummaryOutput,
                crate::error::GetAggregateConfigRuleComplianceSummaryError,
                crate::input::GetAggregateConfigRuleComplianceSummaryInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(inp);
            self
        }
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>Filters the results based on the
        /// ConfigRuleComplianceSummaryFilters object.</p>
        pub fn filters(mut self, inp: crate::model::ConfigRuleComplianceSummaryFilters) -> Self {
            self.inner = self.inner.filters(inp);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::ConfigRuleComplianceSummaryFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>Groups the result based on ACCOUNT_ID or AWS_REGION.</p>
        pub fn group_by_key(
            mut self,
            inp: crate::model::ConfigRuleComplianceSummaryGroupKey,
        ) -> Self {
            self.inner = self.inner.group_by_key(inp);
            self
        }
        pub fn set_group_by_key(
            mut self,
            input: std::option::Option<crate::model::ConfigRuleComplianceSummaryGroupKey>,
        ) -> Self {
            self.inner = self.inner.set_group_by_key(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page.
        /// The default is 1000. You cannot specify a number greater than 1000.
        /// If you specify 0, AWS Config uses the default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use
        /// to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetAggregateConformancePackComplianceSummary<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_aggregate_conformance_pack_compliance_summary_input::Builder,
    }
    impl<C, M, R> GetAggregateConformancePackComplianceSummary<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetAggregateConformancePackComplianceSummaryOutput,
            smithy_http::result::SdkError<
                crate::error::GetAggregateConformancePackComplianceSummaryError,
            >,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetAggregateConformancePackComplianceSummaryInputOperationOutputAlias,
                crate::output::GetAggregateConformancePackComplianceSummaryOutput,
                crate::error::GetAggregateConformancePackComplianceSummaryError,
                crate::input::GetAggregateConformancePackComplianceSummaryInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(inp);
            self
        }
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>Filters the results based on the <code>AggregateConformancePackComplianceSummaryFilters</code> object.</p>
        pub fn filters(
            mut self,
            inp: crate::model::AggregateConformancePackComplianceSummaryFilters,
        ) -> Self {
            self.inner = self.inner.filters(inp);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<
                crate::model::AggregateConformancePackComplianceSummaryFilters,
            >,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>Groups the result based on AWS Account ID or AWS Region.</p>
        pub fn group_by_key(
            mut self,
            inp: crate::model::AggregateConformancePackComplianceSummaryGroupKey,
        ) -> Self {
            self.inner = self.inner.group_by_key(inp);
            self
        }
        pub fn set_group_by_key(
            mut self,
            input: std::option::Option<
                crate::model::AggregateConformancePackComplianceSummaryGroupKey,
            >,
        ) -> Self {
            self.inner = self.inner.set_group_by_key(input);
            self
        }
        /// <p>The maximum number of results returned on each page. The default is maximum. If you specify 0, AWS Config uses the default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetAggregateDiscoveredResourceCounts<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_aggregate_discovered_resource_counts_input::Builder,
    }
    impl<C, M, R> GetAggregateDiscoveredResourceCounts<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetAggregateDiscoveredResourceCountsOutput,
            smithy_http::result::SdkError<crate::error::GetAggregateDiscoveredResourceCountsError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetAggregateDiscoveredResourceCountsInputOperationOutputAlias,
                crate::output::GetAggregateDiscoveredResourceCountsOutput,
                crate::error::GetAggregateDiscoveredResourceCountsError,
                crate::input::GetAggregateDiscoveredResourceCountsInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(inp);
            self
        }
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>Filters the results based on the <code>ResourceCountFilters</code> object.</p>
        pub fn filters(mut self, inp: crate::model::ResourceCountFilters) -> Self {
            self.inner = self.inner.filters(inp);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::ResourceCountFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The key to group the resource counts.</p>
        pub fn group_by_key(mut self, inp: crate::model::ResourceCountGroupKey) -> Self {
            self.inner = self.inner.group_by_key(inp);
            self
        }
        pub fn set_group_by_key(
            mut self,
            input: std::option::Option<crate::model::ResourceCountGroupKey>,
        ) -> Self {
            self.inner = self.inner.set_group_by_key(input);
            self
        }
        /// <p>The maximum number of <a>GroupedResourceCount</a> objects returned on each page. The default is 1000. You cannot specify a number greater than 1000. If you specify 0, AWS Config uses the default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetAggregateResourceConfig<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_aggregate_resource_config_input::Builder,
    }
    impl<C, M, R> GetAggregateResourceConfig<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetAggregateResourceConfigOutput,
            smithy_http::result::SdkError<crate::error::GetAggregateResourceConfigError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetAggregateResourceConfigInputOperationOutputAlias,
                crate::output::GetAggregateResourceConfigOutput,
                crate::error::GetAggregateResourceConfigError,
                crate::input::GetAggregateResourceConfigInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(inp);
            self
        }
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>An object that identifies aggregate resource.</p>
        pub fn resource_identifier(
            mut self,
            inp: crate::model::AggregateResourceIdentifier,
        ) -> Self {
            self.inner = self.inner.resource_identifier(inp);
            self
        }
        pub fn set_resource_identifier(
            mut self,
            input: std::option::Option<crate::model::AggregateResourceIdentifier>,
        ) -> Self {
            self.inner = self.inner.set_resource_identifier(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetComplianceDetailsByConfigRule<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_compliance_details_by_config_rule_input::Builder,
    }
    impl<C, M, R> GetComplianceDetailsByConfigRule<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetComplianceDetailsByConfigRuleOutput,
            smithy_http::result::SdkError<crate::error::GetComplianceDetailsByConfigRuleError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetComplianceDetailsByConfigRuleInputOperationOutputAlias,
                crate::output::GetComplianceDetailsByConfigRuleOutput,
                crate::error::GetComplianceDetailsByConfigRuleError,
                crate::input::GetComplianceDetailsByConfigRuleInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the AWS Config rule for which you want compliance
        /// information.</p>
        pub fn config_rule_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(inp);
            self
        }
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// Appends an item to `ComplianceTypes`.
        ///
        /// To override the contents of this collection use [`set_compliance_types`](Self::set_compliance_types).
        /// <p>Filters the results by compliance.</p>
        /// <p>The allowed values are <code>COMPLIANT</code>,
        /// <code>NON_COMPLIANT</code>, and
        /// <code>NOT_APPLICABLE</code>.</p>
        pub fn compliance_types(mut self, inp: impl Into<crate::model::ComplianceType>) -> Self {
            self.inner = self.inner.compliance_types(inp);
            self
        }
        pub fn set_compliance_types(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ComplianceType>>,
        ) -> Self {
            self.inner = self.inner.set_compliance_types(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page.
        /// The default is 10. You cannot specify a number greater than 100. If
        /// you specify 0, AWS Config uses the default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page
        /// that you use to get the next page of results in a paginated
        /// response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetComplianceDetailsByResource<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_compliance_details_by_resource_input::Builder,
    }
    impl<C, M, R> GetComplianceDetailsByResource<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetComplianceDetailsByResourceOutput,
            smithy_http::result::SdkError<crate::error::GetComplianceDetailsByResourceError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetComplianceDetailsByResourceInputOperationOutputAlias,
                crate::output::GetComplianceDetailsByResourceOutput,
                crate::error::GetComplianceDetailsByResourceError,
                crate::input::GetComplianceDetailsByResourceInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The type of the AWS resource for which you want compliance
        /// information.</p>
        pub fn resource_type(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_type(inp);
            self
        }
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// <p>The ID of the AWS resource for which you want compliance
        /// information.</p>
        pub fn resource_id(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_id(inp);
            self
        }
        pub fn set_resource_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_id(input);
            self
        }
        /// Appends an item to `ComplianceTypes`.
        ///
        /// To override the contents of this collection use [`set_compliance_types`](Self::set_compliance_types).
        /// <p>Filters the results by compliance.</p>
        /// <p>The allowed values are <code>COMPLIANT</code>,
        /// <code>NON_COMPLIANT</code>, and
        /// <code>NOT_APPLICABLE</code>.</p>
        pub fn compliance_types(mut self, inp: impl Into<crate::model::ComplianceType>) -> Self {
            self.inner = self.inner.compliance_types(inp);
            self
        }
        pub fn set_compliance_types(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ComplianceType>>,
        ) -> Self {
            self.inner = self.inner.set_compliance_types(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page
        /// that you use to get the next page of results in a paginated
        /// response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetComplianceSummaryByConfigRule<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_compliance_summary_by_config_rule_input::Builder,
    }
    impl<C, M, R> GetComplianceSummaryByConfigRule<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetComplianceSummaryByConfigRuleOutput,
            smithy_http::result::SdkError<crate::error::GetComplianceSummaryByConfigRuleError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetComplianceSummaryByConfigRuleInputOperationOutputAlias,
                crate::output::GetComplianceSummaryByConfigRuleOutput,
                crate::error::GetComplianceSummaryByConfigRuleError,
                crate::input::GetComplianceSummaryByConfigRuleInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetComplianceSummaryByResourceType<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_compliance_summary_by_resource_type_input::Builder,
    }
    impl<C, M, R> GetComplianceSummaryByResourceType<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetComplianceSummaryByResourceTypeOutput,
            smithy_http::result::SdkError<crate::error::GetComplianceSummaryByResourceTypeError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetComplianceSummaryByResourceTypeInputOperationOutputAlias,
                crate::output::GetComplianceSummaryByResourceTypeOutput,
                crate::error::GetComplianceSummaryByResourceTypeError,
                crate::input::GetComplianceSummaryByResourceTypeInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ResourceTypes`.
        ///
        /// To override the contents of this collection use [`set_resource_types`](Self::set_resource_types).
        /// <p>Specify one or more resource types to get the number of
        /// resources that are compliant and the number that are noncompliant
        /// for each resource type.</p>
        /// <p>For this request, you can specify an AWS resource type such as
        /// <code>AWS::EC2::Instance</code>. You can specify that the
        /// resource type is an AWS account by specifying
        /// <code>AWS::::Account</code>.</p>
        pub fn resource_types(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_types(inp);
            self
        }
        pub fn set_resource_types(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_resource_types(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetConformancePackComplianceDetails<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_conformance_pack_compliance_details_input::Builder,
    }
    impl<C, M, R> GetConformancePackComplianceDetails<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetConformancePackComplianceDetailsOutput,
            smithy_http::result::SdkError<crate::error::GetConformancePackComplianceDetailsError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetConformancePackComplianceDetailsInputOperationOutputAlias,
                crate::output::GetConformancePackComplianceDetailsOutput,
                crate::error::GetConformancePackComplianceDetailsError,
                crate::input::GetConformancePackComplianceDetailsInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>Name of the conformance pack.</p>
        pub fn conformance_pack_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.conformance_pack_name(inp);
            self
        }
        pub fn set_conformance_pack_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_name(input);
            self
        }
        /// <p>A <code>ConformancePackEvaluationFilters</code> object.</p>
        pub fn filters(mut self, inp: crate::model::ConformancePackEvaluationFilters) -> Self {
            self.inner = self.inner.filters(inp);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::ConformancePackEvaluationFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The maximum number of evaluation results returned on each page. If you do no specify a number, AWS Config uses the default. The default is 100.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetConformancePackComplianceSummary<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_conformance_pack_compliance_summary_input::Builder,
    }
    impl<C, M, R> GetConformancePackComplianceSummary<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetConformancePackComplianceSummaryOutput,
            smithy_http::result::SdkError<crate::error::GetConformancePackComplianceSummaryError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetConformancePackComplianceSummaryInputOperationOutputAlias,
                crate::output::GetConformancePackComplianceSummaryOutput,
                crate::error::GetConformancePackComplianceSummaryError,
                crate::input::GetConformancePackComplianceSummaryInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ConformancePackNames`.
        ///
        /// To override the contents of this collection use [`set_conformance_pack_names`](Self::set_conformance_pack_names).
        /// <p>Names of conformance packs.</p>
        pub fn conformance_pack_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.conformance_pack_names(inp);
            self
        }
        pub fn set_conformance_pack_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_names(input);
            self
        }
        /// <p>The maximum number of conformance packs returned on each page.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetDiscoveredResourceCounts<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_discovered_resource_counts_input::Builder,
    }
    impl<C, M, R> GetDiscoveredResourceCounts<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetDiscoveredResourceCountsOutput,
            smithy_http::result::SdkError<crate::error::GetDiscoveredResourceCountsError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetDiscoveredResourceCountsInputOperationOutputAlias,
                crate::output::GetDiscoveredResourceCountsOutput,
                crate::error::GetDiscoveredResourceCountsError,
                crate::input::GetDiscoveredResourceCountsInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `resourceTypes`.
        ///
        /// To override the contents of this collection use [`set_resource_types`](Self::set_resource_types).
        /// <p>The comma-separated list that specifies the resource types that
        /// you want AWS Config to return (for example,
        /// <code>"AWS::EC2::Instance"</code>,
        /// <code>"AWS::IAM::User"</code>).</p>
        /// <p>If a value for <code>resourceTypes</code> is not specified, AWS
        /// Config returns all resource types that AWS Config is recording in
        /// the region for your account.</p>
        /// <note>
        /// <p>If the configuration recorder is turned off, AWS Config
        /// returns an empty list of <a>ResourceCount</a>
        /// objects. If the configuration recorder is not recording a
        /// specific resource type (for example, S3 buckets), that resource
        /// type is not returned in the list of <a>ResourceCount</a> objects.</p>
        /// </note>
        pub fn resource_types(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_types(inp);
            self
        }
        pub fn set_resource_types(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_resource_types(input);
            self
        }
        /// <p>The maximum number of <a>ResourceCount</a> objects
        /// returned on each page. The default is 100. You cannot specify a
        /// number greater than 100. If you specify 0, AWS Config uses the
        /// default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page
        /// that you use to get the next page of results in a paginated
        /// response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetOrganizationConfigRuleDetailedStatus<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_organization_config_rule_detailed_status_input::Builder,
    }
    impl<C, M, R> GetOrganizationConfigRuleDetailedStatus<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetOrganizationConfigRuleDetailedStatusOutput,
            smithy_http::result::SdkError<
                crate::error::GetOrganizationConfigRuleDetailedStatusError,
            >,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetOrganizationConfigRuleDetailedStatusInputOperationOutputAlias,
                crate::output::GetOrganizationConfigRuleDetailedStatusOutput,
                crate::error::GetOrganizationConfigRuleDetailedStatusError,
                crate::input::GetOrganizationConfigRuleDetailedStatusInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of organization config rule for which you want status details for member accounts.</p>
        pub fn organization_config_rule_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_config_rule_name(inp);
            self
        }
        pub fn set_organization_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_organization_config_rule_name(input);
            self
        }
        /// <p>A <code>StatusDetailFilters</code> object.</p>
        pub fn filters(mut self, inp: crate::model::StatusDetailFilters) -> Self {
            self.inner = self.inner.filters(inp);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::StatusDetailFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The maximum number of <code>OrganizationConfigRuleDetailedStatus</code> returned on each page. If you do not specify a number, AWS Config uses the default. The default is 100.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetOrganizationConformancePackDetailedStatus<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_organization_conformance_pack_detailed_status_input::Builder,
    }
    impl<C, M, R> GetOrganizationConformancePackDetailedStatus<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetOrganizationConformancePackDetailedStatusOutput,
            smithy_http::result::SdkError<
                crate::error::GetOrganizationConformancePackDetailedStatusError,
            >,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetOrganizationConformancePackDetailedStatusInputOperationOutputAlias,
                crate::output::GetOrganizationConformancePackDetailedStatusOutput,
                crate::error::GetOrganizationConformancePackDetailedStatusError,
                crate::input::GetOrganizationConformancePackDetailedStatusInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of organization conformance pack for which you want status details for member accounts.</p>
        pub fn organization_conformance_pack_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_conformance_pack_name(inp);
            self
        }
        pub fn set_organization_conformance_pack_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_organization_conformance_pack_name(input);
            self
        }
        /// <p>An <code>OrganizationResourceDetailedStatusFilters</code> object.</p>
        pub fn filters(
            mut self,
            inp: crate::model::OrganizationResourceDetailedStatusFilters,
        ) -> Self {
            self.inner = self.inner.filters(inp);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::OrganizationResourceDetailedStatusFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The maximum number of <code>OrganizationConformancePackDetailedStatuses</code> returned on each page.
        /// If you do not specify a number, AWS Config uses the default. The default is 100. </p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The nextToken string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetResourceConfigHistory<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_resource_config_history_input::Builder,
    }
    impl<C, M, R> GetResourceConfigHistory<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetResourceConfigHistoryOutput,
            smithy_http::result::SdkError<crate::error::GetResourceConfigHistoryError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetResourceConfigHistoryInputOperationOutputAlias,
                crate::output::GetResourceConfigHistoryOutput,
                crate::error::GetResourceConfigHistoryError,
                crate::input::GetResourceConfigHistoryInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The resource type.</p>
        pub fn resource_type(mut self, inp: crate::model::ResourceType) -> Self {
            self.inner = self.inner.resource_type(inp);
            self
        }
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<crate::model::ResourceType>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// <p>The ID of the resource (for example.,
        /// <code>sg-xxxxxx</code>).</p>
        pub fn resource_id(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_id(inp);
            self
        }
        pub fn set_resource_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_id(input);
            self
        }
        /// <p>The time stamp that indicates a later time. If not specified,
        /// current time is taken.</p>
        pub fn later_time(mut self, inp: smithy_types::Instant) -> Self {
            self.inner = self.inner.later_time(inp);
            self
        }
        pub fn set_later_time(mut self, input: std::option::Option<smithy_types::Instant>) -> Self {
            self.inner = self.inner.set_later_time(input);
            self
        }
        /// <p>The time stamp that indicates an earlier time. If not
        /// specified, the action returns paginated results that contain
        /// configuration items that start when the first configuration item was
        /// recorded.</p>
        pub fn earlier_time(mut self, inp: smithy_types::Instant) -> Self {
            self.inner = self.inner.earlier_time(inp);
            self
        }
        pub fn set_earlier_time(
            mut self,
            input: std::option::Option<smithy_types::Instant>,
        ) -> Self {
            self.inner = self.inner.set_earlier_time(input);
            self
        }
        /// <p>The chronological order for configuration items listed. By
        /// default, the results are listed in reverse chronological
        /// order.</p>
        pub fn chronological_order(mut self, inp: crate::model::ChronologicalOrder) -> Self {
            self.inner = self.inner.chronological_order(inp);
            self
        }
        pub fn set_chronological_order(
            mut self,
            input: std::option::Option<crate::model::ChronologicalOrder>,
        ) -> Self {
            self.inner = self.inner.set_chronological_order(input);
            self
        }
        /// <p>The maximum number of configuration items returned on each
        /// page. The default is 10. You cannot specify a number greater than
        /// 100. If you specify 0, AWS Config uses the default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page
        /// that you use to get the next page of results in a paginated
        /// response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct GetStoredQuery<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::get_stored_query_input::Builder,
    }
    impl<C, M, R> GetStoredQuery<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::GetStoredQueryOutput,
            smithy_http::result::SdkError<crate::error::GetStoredQueryError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::GetStoredQueryInputOperationOutputAlias,
                crate::output::GetStoredQueryOutput,
                crate::error::GetStoredQueryError,
                crate::input::GetStoredQueryInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the query.</p>
        pub fn query_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.query_name(inp);
            self
        }
        pub fn set_query_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_query_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ListAggregateDiscoveredResources<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::list_aggregate_discovered_resources_input::Builder,
    }
    impl<C, M, R> ListAggregateDiscoveredResources<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ListAggregateDiscoveredResourcesOutput,
            smithy_http::result::SdkError<crate::error::ListAggregateDiscoveredResourcesError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::ListAggregateDiscoveredResourcesInputOperationOutputAlias,
                crate::output::ListAggregateDiscoveredResourcesOutput,
                crate::error::ListAggregateDiscoveredResourcesError,
                crate::input::ListAggregateDiscoveredResourcesInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator. </p>
        pub fn configuration_aggregator_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(inp);
            self
        }
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>The type of resources that you want AWS Config to list in the response.</p>
        pub fn resource_type(mut self, inp: crate::model::ResourceType) -> Self {
            self.inner = self.inner.resource_type(inp);
            self
        }
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<crate::model::ResourceType>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// <p>Filters the results based on the <code>ResourceFilters</code> object.</p>
        pub fn filters(mut self, inp: crate::model::ResourceFilters) -> Self {
            self.inner = self.inner.filters(inp);
            self
        }
        pub fn set_filters(
            mut self,
            input: std::option::Option<crate::model::ResourceFilters>,
        ) -> Self {
            self.inner = self.inner.set_filters(input);
            self
        }
        /// <p>The maximum number of resource identifiers returned on each page. You cannot specify a number greater than 100. If you specify 0, AWS Config uses the default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ListDiscoveredResources<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::list_discovered_resources_input::Builder,
    }
    impl<C, M, R> ListDiscoveredResources<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ListDiscoveredResourcesOutput,
            smithy_http::result::SdkError<crate::error::ListDiscoveredResourcesError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::ListDiscoveredResourcesInputOperationOutputAlias,
                crate::output::ListDiscoveredResourcesOutput,
                crate::error::ListDiscoveredResourcesError,
                crate::input::ListDiscoveredResourcesInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The type of resources that you want AWS Config to list in the
        /// response.</p>
        pub fn resource_type(mut self, inp: crate::model::ResourceType) -> Self {
            self.inner = self.inner.resource_type(inp);
            self
        }
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<crate::model::ResourceType>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// Appends an item to `resourceIds`.
        ///
        /// To override the contents of this collection use [`set_resource_ids`](Self::set_resource_ids).
        /// <p>The IDs of only those resources that you want AWS Config to
        /// list in the response. If you do not specify this parameter, AWS
        /// Config lists all resources of the specified type that it has
        /// discovered.</p>
        pub fn resource_ids(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_ids(inp);
            self
        }
        pub fn set_resource_ids(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_resource_ids(input);
            self
        }
        /// <p>The custom name of only those resources that you want AWS
        /// Config to list in the response. If you do not specify this
        /// parameter, AWS Config lists all resources of the specified type that
        /// it has discovered.</p>
        pub fn resource_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_name(inp);
            self
        }
        pub fn set_resource_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_name(input);
            self
        }
        /// <p>The maximum number of resource identifiers returned on each
        /// page. The default is 100. You cannot specify a number greater than
        /// 100. If you specify 0, AWS Config uses the default.</p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>Specifies whether AWS Config includes deleted resources in the
        /// results. By default, deleted resources are not included.</p>
        pub fn include_deleted_resources(mut self, inp: bool) -> Self {
            self.inner = self.inner.include_deleted_resources(inp);
            self
        }
        pub fn set_include_deleted_resources(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_include_deleted_resources(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page
        /// that you use to get the next page of results in a paginated
        /// response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ListStoredQueries<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::list_stored_queries_input::Builder,
    }
    impl<C, M, R> ListStoredQueries<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ListStoredQueriesOutput,
            smithy_http::result::SdkError<crate::error::ListStoredQueriesError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::ListStoredQueriesInputOperationOutputAlias,
                crate::output::ListStoredQueriesOutput,
                crate::error::ListStoredQueriesError,
                crate::input::ListStoredQueriesInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The nextToken string returned in a previous request that you use to request the next page of results in a paginated response.</p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
        /// <p>The maximum number of results to be returned with a single call.</p>
        pub fn max_results(mut self, inp: i32) -> Self {
            self.inner = self.inner.max_results(inp);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_results(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct ListTagsForResource<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::list_tags_for_resource_input::Builder,
    }
    impl<C, M, R> ListTagsForResource<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::ListTagsForResourceOutput,
            smithy_http::result::SdkError<crate::error::ListTagsForResourceError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::ListTagsForResourceInputOperationOutputAlias,
                crate::output::ListTagsForResourceOutput,
                crate::error::ListTagsForResourceError,
                crate::input::ListTagsForResourceInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The Amazon Resource Name (ARN) that identifies the resource for which to list the tags. Currently, the supported resources are <code>ConfigRule</code>, <code>ConfigurationAggregator</code> and <code>AggregatorAuthorization</code>.</p>
        pub fn resource_arn(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_arn(inp);
            self
        }
        pub fn set_resource_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_arn(input);
            self
        }
        /// <p>The maximum number of tags returned on each page. The limit maximum is 50. You cannot specify a number greater than 50. If you specify 0, AWS Config uses the default. </p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned on a previous page that you use to get the next page of results in a paginated response. </p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutAggregationAuthorization<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::put_aggregation_authorization_input::Builder,
    }
    impl<C, M, R> PutAggregationAuthorization<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutAggregationAuthorizationOutput,
            smithy_http::result::SdkError<crate::error::PutAggregationAuthorizationError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::PutAggregationAuthorizationInputOperationOutputAlias,
                crate::output::PutAggregationAuthorizationOutput,
                crate::error::PutAggregationAuthorizationError,
                crate::input::PutAggregationAuthorizationInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The 12-digit account ID of the account authorized to aggregate data.</p>
        pub fn authorized_account_id(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.authorized_account_id(inp);
            self
        }
        pub fn set_authorized_account_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_authorized_account_id(input);
            self
        }
        /// <p>The region authorized to collect aggregated data.</p>
        pub fn authorized_aws_region(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.authorized_aws_region(inp);
            self
        }
        pub fn set_authorized_aws_region(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_authorized_aws_region(input);
            self
        }
        /// Appends an item to `Tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        /// <p>An array of tag object.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutConfigRule<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::put_config_rule_input::Builder,
    }
    impl<C, M, R> PutConfigRule<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutConfigRuleOutput,
            smithy_http::result::SdkError<crate::error::PutConfigRuleError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::PutConfigRuleInputOperationOutputAlias,
                crate::output::PutConfigRuleOutput,
                crate::error::PutConfigRuleError,
                crate::input::PutConfigRuleInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The rule that you want to add to your account.</p>
        pub fn config_rule(mut self, inp: crate::model::ConfigRule) -> Self {
            self.inner = self.inner.config_rule(inp);
            self
        }
        pub fn set_config_rule(
            mut self,
            input: std::option::Option<crate::model::ConfigRule>,
        ) -> Self {
            self.inner = self.inner.set_config_rule(input);
            self
        }
        /// Appends an item to `Tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        /// <p>An array of tag object.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutConfigurationAggregator<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::put_configuration_aggregator_input::Builder,
    }
    impl<C, M, R> PutConfigurationAggregator<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutConfigurationAggregatorOutput,
            smithy_http::result::SdkError<crate::error::PutConfigurationAggregatorError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::PutConfigurationAggregatorInputOperationOutputAlias,
                crate::output::PutConfigurationAggregatorOutput,
                crate::error::PutConfigurationAggregatorError,
                crate::input::PutConfigurationAggregatorInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(inp);
            self
        }
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// Appends an item to `AccountAggregationSources`.
        ///
        /// To override the contents of this collection use [`set_account_aggregation_sources`](Self::set_account_aggregation_sources).
        /// <p>A list of AccountAggregationSource object.
        /// </p>
        pub fn account_aggregation_sources(
            mut self,
            inp: impl Into<crate::model::AccountAggregationSource>,
        ) -> Self {
            self.inner = self.inner.account_aggregation_sources(inp);
            self
        }
        pub fn set_account_aggregation_sources(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::AccountAggregationSource>>,
        ) -> Self {
            self.inner = self.inner.set_account_aggregation_sources(input);
            self
        }
        /// <p>An OrganizationAggregationSource object.</p>
        pub fn organization_aggregation_source(
            mut self,
            inp: crate::model::OrganizationAggregationSource,
        ) -> Self {
            self.inner = self.inner.organization_aggregation_source(inp);
            self
        }
        pub fn set_organization_aggregation_source(
            mut self,
            input: std::option::Option<crate::model::OrganizationAggregationSource>,
        ) -> Self {
            self.inner = self.inner.set_organization_aggregation_source(input);
            self
        }
        /// Appends an item to `Tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        /// <p>An array of tag object.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutConfigurationRecorder<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::put_configuration_recorder_input::Builder,
    }
    impl<C, M, R> PutConfigurationRecorder<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutConfigurationRecorderOutput,
            smithy_http::result::SdkError<crate::error::PutConfigurationRecorderError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::PutConfigurationRecorderInputOperationOutputAlias,
                crate::output::PutConfigurationRecorderOutput,
                crate::error::PutConfigurationRecorderError,
                crate::input::PutConfigurationRecorderInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The configuration recorder object that records each
        /// configuration change made to the resources.</p>
        pub fn configuration_recorder(mut self, inp: crate::model::ConfigurationRecorder) -> Self {
            self.inner = self.inner.configuration_recorder(inp);
            self
        }
        pub fn set_configuration_recorder(
            mut self,
            input: std::option::Option<crate::model::ConfigurationRecorder>,
        ) -> Self {
            self.inner = self.inner.set_configuration_recorder(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutConformancePack<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::put_conformance_pack_input::Builder,
    }
    impl<C, M, R> PutConformancePack<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutConformancePackOutput,
            smithy_http::result::SdkError<crate::error::PutConformancePackError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::PutConformancePackInputOperationOutputAlias,
                crate::output::PutConformancePackOutput,
                crate::error::PutConformancePackError,
                crate::input::PutConformancePackInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>Name of the conformance pack you want to create.</p>
        pub fn conformance_pack_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.conformance_pack_name(inp);
            self
        }
        pub fn set_conformance_pack_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_name(input);
            self
        }
        /// <p>Location of file containing the template body (<code>s3://bucketname/prefix</code>). The uri must point to the conformance pack template (max size: 300 KB) that is located in an Amazon S3 bucket in the same region as the conformance pack. </p>
        /// <note>
        /// <p>You must have access to read Amazon S3 bucket.</p>
        /// </note>
        pub fn template_s3_uri(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.template_s3_uri(inp);
            self
        }
        pub fn set_template_s3_uri(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_template_s3_uri(input);
            self
        }
        /// <p>A string containing full conformance pack template body. Structure containing the template body with a minimum length of 1 byte and a maximum length of 51,200 bytes.</p>
        /// <note>
        /// <p>You can only use a YAML template with one resource type, that is, config rule and a remediation action. </p>
        /// </note>
        pub fn template_body(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.template_body(inp);
            self
        }
        pub fn set_template_body(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_template_body(input);
            self
        }
        /// <p>Amazon S3 bucket where AWS Config stores conformance pack templates.</p>
        /// <note>
        /// <p>This field is optional.</p>
        /// </note>
        pub fn delivery_s3_bucket(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_s3_bucket(inp);
            self
        }
        pub fn set_delivery_s3_bucket(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_delivery_s3_bucket(input);
            self
        }
        /// <p>The prefix for the Amazon S3 bucket. </p>
        /// <note>
        /// <p>This field is optional.</p>
        /// </note>
        pub fn delivery_s3_key_prefix(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_s3_key_prefix(inp);
            self
        }
        pub fn set_delivery_s3_key_prefix(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_delivery_s3_key_prefix(input);
            self
        }
        /// Appends an item to `ConformancePackInputParameters`.
        ///
        /// To override the contents of this collection use [`set_conformance_pack_input_parameters`](Self::set_conformance_pack_input_parameters).
        /// <p>A list of <code>ConformancePackInputParameter</code> objects.</p>
        pub fn conformance_pack_input_parameters(
            mut self,
            inp: impl Into<crate::model::ConformancePackInputParameter>,
        ) -> Self {
            self.inner = self.inner.conformance_pack_input_parameters(inp);
            self
        }
        pub fn set_conformance_pack_input_parameters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ConformancePackInputParameter>>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_input_parameters(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutDeliveryChannel<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::put_delivery_channel_input::Builder,
    }
    impl<C, M, R> PutDeliveryChannel<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutDeliveryChannelOutput,
            smithy_http::result::SdkError<crate::error::PutDeliveryChannelError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::PutDeliveryChannelInputOperationOutputAlias,
                crate::output::PutDeliveryChannelOutput,
                crate::error::PutDeliveryChannelError,
                crate::input::PutDeliveryChannelInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The configuration delivery channel object that delivers the
        /// configuration information to an Amazon S3 bucket and to an Amazon
        /// SNS topic.</p>
        pub fn delivery_channel(mut self, inp: crate::model::DeliveryChannel) -> Self {
            self.inner = self.inner.delivery_channel(inp);
            self
        }
        pub fn set_delivery_channel(
            mut self,
            input: std::option::Option<crate::model::DeliveryChannel>,
        ) -> Self {
            self.inner = self.inner.set_delivery_channel(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutEvaluations<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::put_evaluations_input::Builder,
    }
    impl<C, M, R> PutEvaluations<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutEvaluationsOutput,
            smithy_http::result::SdkError<crate::error::PutEvaluationsError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::PutEvaluationsInputOperationOutputAlias,
                crate::output::PutEvaluationsOutput,
                crate::error::PutEvaluationsError,
                crate::input::PutEvaluationsInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `Evaluations`.
        ///
        /// To override the contents of this collection use [`set_evaluations`](Self::set_evaluations).
        /// <p>The assessments that the AWS Lambda function performs. Each
        /// evaluation identifies an AWS resource and indicates whether it
        /// complies with the AWS Config rule that invokes the AWS Lambda
        /// function.</p>
        pub fn evaluations(mut self, inp: impl Into<crate::model::Evaluation>) -> Self {
            self.inner = self.inner.evaluations(inp);
            self
        }
        pub fn set_evaluations(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Evaluation>>,
        ) -> Self {
            self.inner = self.inner.set_evaluations(input);
            self
        }
        /// <p>An encrypted token that associates an evaluation with an AWS
        /// Config rule. Identifies the rule and the event that triggered the
        /// evaluation.</p>
        pub fn result_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.result_token(inp);
            self
        }
        pub fn set_result_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_result_token(input);
            self
        }
        /// <p>Use this parameter to specify a test run for
        /// <code>PutEvaluations</code>. You can verify whether your AWS
        /// Lambda function will deliver evaluation results to AWS Config. No
        /// updates occur to your existing evaluations, and evaluation results
        /// are not sent to AWS Config.</p>
        /// <note>
        /// <p>When <code>TestMode</code> is <code>true</code>,
        /// <code>PutEvaluations</code> doesn't require a valid value
        /// for the <code>ResultToken</code> parameter, but the value cannot
        /// be null.</p>
        /// </note>
        pub fn test_mode(mut self, inp: bool) -> Self {
            self.inner = self.inner.test_mode(inp);
            self
        }
        pub fn set_test_mode(mut self, input: std::option::Option<bool>) -> Self {
            self.inner = self.inner.set_test_mode(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutExternalEvaluation<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::put_external_evaluation_input::Builder,
    }
    impl<C, M, R> PutExternalEvaluation<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutExternalEvaluationOutput,
            smithy_http::result::SdkError<crate::error::PutExternalEvaluationError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::PutExternalEvaluationInputOperationOutputAlias,
                crate::output::PutExternalEvaluationOutput,
                crate::error::PutExternalEvaluationError,
                crate::input::PutExternalEvaluationInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the AWS Config rule.</p>
        pub fn config_rule_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(inp);
            self
        }
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// <p>An <code>ExternalEvaluation</code> object that provides details about compliance.</p>
        pub fn external_evaluation(mut self, inp: crate::model::ExternalEvaluation) -> Self {
            self.inner = self.inner.external_evaluation(inp);
            self
        }
        pub fn set_external_evaluation(
            mut self,
            input: std::option::Option<crate::model::ExternalEvaluation>,
        ) -> Self {
            self.inner = self.inner.set_external_evaluation(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutOrganizationConfigRule<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::put_organization_config_rule_input::Builder,
    }
    impl<C, M, R> PutOrganizationConfigRule<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutOrganizationConfigRuleOutput,
            smithy_http::result::SdkError<crate::error::PutOrganizationConfigRuleError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::PutOrganizationConfigRuleInputOperationOutputAlias,
                crate::output::PutOrganizationConfigRuleOutput,
                crate::error::PutOrganizationConfigRuleError,
                crate::input::PutOrganizationConfigRuleInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name that you assign to an organization config rule.</p>
        pub fn organization_config_rule_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_config_rule_name(inp);
            self
        }
        pub fn set_organization_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_organization_config_rule_name(input);
            self
        }
        /// <p>An <code>OrganizationManagedRuleMetadata</code> object. </p>
        pub fn organization_managed_rule_metadata(
            mut self,
            inp: crate::model::OrganizationManagedRuleMetadata,
        ) -> Self {
            self.inner = self.inner.organization_managed_rule_metadata(inp);
            self
        }
        pub fn set_organization_managed_rule_metadata(
            mut self,
            input: std::option::Option<crate::model::OrganizationManagedRuleMetadata>,
        ) -> Self {
            self.inner = self.inner.set_organization_managed_rule_metadata(input);
            self
        }
        /// <p>An <code>OrganizationCustomRuleMetadata</code> object.</p>
        pub fn organization_custom_rule_metadata(
            mut self,
            inp: crate::model::OrganizationCustomRuleMetadata,
        ) -> Self {
            self.inner = self.inner.organization_custom_rule_metadata(inp);
            self
        }
        pub fn set_organization_custom_rule_metadata(
            mut self,
            input: std::option::Option<crate::model::OrganizationCustomRuleMetadata>,
        ) -> Self {
            self.inner = self.inner.set_organization_custom_rule_metadata(input);
            self
        }
        /// Appends an item to `ExcludedAccounts`.
        ///
        /// To override the contents of this collection use [`set_excluded_accounts`](Self::set_excluded_accounts).
        /// <p>A comma-separated list of accounts that you want to exclude from an organization config rule.</p>
        pub fn excluded_accounts(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.excluded_accounts(inp);
            self
        }
        pub fn set_excluded_accounts(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_excluded_accounts(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutOrganizationConformancePack<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::put_organization_conformance_pack_input::Builder,
    }
    impl<C, M, R> PutOrganizationConformancePack<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutOrganizationConformancePackOutput,
            smithy_http::result::SdkError<crate::error::PutOrganizationConformancePackError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::PutOrganizationConformancePackInputOperationOutputAlias,
                crate::output::PutOrganizationConformancePackOutput,
                crate::error::PutOrganizationConformancePackError,
                crate::input::PutOrganizationConformancePackInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>Name of the organization conformance pack you want to create.</p>
        pub fn organization_conformance_pack_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.organization_conformance_pack_name(inp);
            self
        }
        pub fn set_organization_conformance_pack_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_organization_conformance_pack_name(input);
            self
        }
        /// <p>Location of file containing the template body. The uri must point to the conformance pack template
        /// (max size: 300 KB).</p>
        /// <note>
        /// <p>You must have access to read Amazon S3 bucket.</p>
        /// </note>
        pub fn template_s3_uri(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.template_s3_uri(inp);
            self
        }
        pub fn set_template_s3_uri(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_template_s3_uri(input);
            self
        }
        /// <p>A string containing full conformance pack template body. Structure containing the template body
        /// with a minimum length of 1 byte and a maximum length of 51,200 bytes.</p>
        pub fn template_body(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.template_body(inp);
            self
        }
        pub fn set_template_body(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_template_body(input);
            self
        }
        /// <p>Amazon S3 bucket where AWS Config stores conformance pack templates.</p>
        /// <note>
        /// <p>This field is optional. If used, it must be prefixed with <code>awsconfigconforms</code>.</p>
        /// </note>
        pub fn delivery_s3_bucket(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_s3_bucket(inp);
            self
        }
        pub fn set_delivery_s3_bucket(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_delivery_s3_bucket(input);
            self
        }
        /// <p>The prefix for the Amazon S3 bucket.</p>
        /// <note>
        /// <p>This field is optional.</p>
        /// </note>
        pub fn delivery_s3_key_prefix(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.delivery_s3_key_prefix(inp);
            self
        }
        pub fn set_delivery_s3_key_prefix(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_delivery_s3_key_prefix(input);
            self
        }
        /// Appends an item to `ConformancePackInputParameters`.
        ///
        /// To override the contents of this collection use [`set_conformance_pack_input_parameters`](Self::set_conformance_pack_input_parameters).
        /// <p>A list of <code>ConformancePackInputParameter</code> objects.</p>
        pub fn conformance_pack_input_parameters(
            mut self,
            inp: impl Into<crate::model::ConformancePackInputParameter>,
        ) -> Self {
            self.inner = self.inner.conformance_pack_input_parameters(inp);
            self
        }
        pub fn set_conformance_pack_input_parameters(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ConformancePackInputParameter>>,
        ) -> Self {
            self.inner = self.inner.set_conformance_pack_input_parameters(input);
            self
        }
        /// Appends an item to `ExcludedAccounts`.
        ///
        /// To override the contents of this collection use [`set_excluded_accounts`](Self::set_excluded_accounts).
        /// <p>A list of AWS accounts to be excluded from an organization conformance pack while deploying a conformance pack.</p>
        pub fn excluded_accounts(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.excluded_accounts(inp);
            self
        }
        pub fn set_excluded_accounts(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_excluded_accounts(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutRemediationConfigurations<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::put_remediation_configurations_input::Builder,
    }
    impl<C, M, R> PutRemediationConfigurations<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutRemediationConfigurationsOutput,
            smithy_http::result::SdkError<crate::error::PutRemediationConfigurationsError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::PutRemediationConfigurationsInputOperationOutputAlias,
                crate::output::PutRemediationConfigurationsOutput,
                crate::error::PutRemediationConfigurationsError,
                crate::input::PutRemediationConfigurationsInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `RemediationConfigurations`.
        ///
        /// To override the contents of this collection use [`set_remediation_configurations`](Self::set_remediation_configurations).
        /// <p>A list of remediation configuration objects.</p>
        pub fn remediation_configurations(
            mut self,
            inp: impl Into<crate::model::RemediationConfiguration>,
        ) -> Self {
            self.inner = self.inner.remediation_configurations(inp);
            self
        }
        pub fn set_remediation_configurations(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::RemediationConfiguration>>,
        ) -> Self {
            self.inner = self.inner.set_remediation_configurations(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutRemediationExceptions<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::put_remediation_exceptions_input::Builder,
    }
    impl<C, M, R> PutRemediationExceptions<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutRemediationExceptionsOutput,
            smithy_http::result::SdkError<crate::error::PutRemediationExceptionsError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::PutRemediationExceptionsInputOperationOutputAlias,
                crate::output::PutRemediationExceptionsOutput,
                crate::error::PutRemediationExceptionsError,
                crate::input::PutRemediationExceptionsInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the AWS Config rule for which you want to create remediation exception.</p>
        pub fn config_rule_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(inp);
            self
        }
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// Appends an item to `ResourceKeys`.
        ///
        /// To override the contents of this collection use [`set_resource_keys`](Self::set_resource_keys).
        /// <p>An exception list of resource exception keys to be processed with the current request. AWS Config adds exception for each resource key. For example, AWS Config adds 3 exceptions for 3 resource keys. </p>
        pub fn resource_keys(
            mut self,
            inp: impl Into<crate::model::RemediationExceptionResourceKey>,
        ) -> Self {
            self.inner = self.inner.resource_keys(inp);
            self
        }
        pub fn set_resource_keys(
            mut self,
            input: std::option::Option<
                std::vec::Vec<crate::model::RemediationExceptionResourceKey>,
            >,
        ) -> Self {
            self.inner = self.inner.set_resource_keys(input);
            self
        }
        /// <p>The message contains an explanation of the exception.</p>
        pub fn message(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.message(inp);
            self
        }
        pub fn set_message(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_message(input);
            self
        }
        /// <p>The exception is automatically deleted after the expiration date.</p>
        pub fn expiration_time(mut self, inp: smithy_types::Instant) -> Self {
            self.inner = self.inner.expiration_time(inp);
            self
        }
        pub fn set_expiration_time(
            mut self,
            input: std::option::Option<smithy_types::Instant>,
        ) -> Self {
            self.inner = self.inner.set_expiration_time(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutResourceConfig<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::put_resource_config_input::Builder,
    }
    impl<C, M, R> PutResourceConfig<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutResourceConfigOutput,
            smithy_http::result::SdkError<crate::error::PutResourceConfigError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::PutResourceConfigInputOperationOutputAlias,
                crate::output::PutResourceConfigOutput,
                crate::error::PutResourceConfigError,
                crate::input::PutResourceConfigInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The type of the resource. The custom resource type must be registered with AWS CloudFormation. </p>
        /// <note>
        /// <p>You cannot use the organization names “aws”, “amzn”, “amazon”, “alexa”, “custom” with custom resource types. It is the first part of the ResourceType up to the first ::.</p>
        /// </note>
        pub fn resource_type(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_type(inp);
            self
        }
        pub fn set_resource_type(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_type(input);
            self
        }
        /// <p>Version of the schema registered for the ResourceType in AWS CloudFormation.</p>
        pub fn schema_version_id(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.schema_version_id(inp);
            self
        }
        pub fn set_schema_version_id(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_schema_version_id(input);
            self
        }
        /// <p>Unique identifier of the resource.</p>
        pub fn resource_id(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_id(inp);
            self
        }
        pub fn set_resource_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_id(input);
            self
        }
        /// <p>Name of the resource.</p>
        pub fn resource_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_name(inp);
            self
        }
        pub fn set_resource_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_resource_name(input);
            self
        }
        /// <p>The configuration object of the resource in valid JSON format. It must match the schema registered with AWS CloudFormation.</p>
        /// <note>
        /// <p>The configuration JSON must not exceed 64 KB.</p>
        /// </note>
        pub fn configuration(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.configuration(inp);
            self
        }
        pub fn set_configuration(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration(input);
            self
        }
        /// Adds a key-value pair to `Tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        /// <p>Tags associated with the resource.</p>
        pub fn tags(
            mut self,
            k: impl Into<std::string::String>,
            v: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.tags(k, v);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<
                std::collections::HashMap<std::string::String, std::string::String>,
            >,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutRetentionConfiguration<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::put_retention_configuration_input::Builder,
    }
    impl<C, M, R> PutRetentionConfiguration<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutRetentionConfigurationOutput,
            smithy_http::result::SdkError<crate::error::PutRetentionConfigurationError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::PutRetentionConfigurationInputOperationOutputAlias,
                crate::output::PutRetentionConfigurationOutput,
                crate::error::PutRetentionConfigurationError,
                crate::input::PutRetentionConfigurationInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>Number of days AWS Config stores your historical
        /// information.</p>
        /// <note>
        /// <p>Currently, only applicable to the configuration item
        /// history.</p>
        /// </note>
        pub fn retention_period_in_days(mut self, inp: i32) -> Self {
            self.inner = self.inner.retention_period_in_days(inp);
            self
        }
        pub fn set_retention_period_in_days(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_retention_period_in_days(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct PutStoredQuery<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::put_stored_query_input::Builder,
    }
    impl<C, M, R> PutStoredQuery<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::PutStoredQueryOutput,
            smithy_http::result::SdkError<crate::error::PutStoredQueryError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::PutStoredQueryInputOperationOutputAlias,
                crate::output::PutStoredQueryOutput,
                crate::error::PutStoredQueryError,
                crate::input::PutStoredQueryInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>A list of <code>StoredQuery</code> objects.
        /// The mandatory fields are <code>QueryName</code> and <code>Expression</code>.</p>
        /// <note>
        /// <p>When you are creating a query, you must provide a query name and an expression.
        /// When you are updating a query, you must provide a query name but updating the description is optional.</p>
        /// </note>
        pub fn stored_query(mut self, inp: crate::model::StoredQuery) -> Self {
            self.inner = self.inner.stored_query(inp);
            self
        }
        pub fn set_stored_query(
            mut self,
            input: std::option::Option<crate::model::StoredQuery>,
        ) -> Self {
            self.inner = self.inner.set_stored_query(input);
            self
        }
        /// Appends an item to `Tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        /// <p>A list of <code>Tags</code> object.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct SelectAggregateResourceConfig<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::select_aggregate_resource_config_input::Builder,
    }
    impl<C, M, R> SelectAggregateResourceConfig<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::SelectAggregateResourceConfigOutput,
            smithy_http::result::SdkError<crate::error::SelectAggregateResourceConfigError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::SelectAggregateResourceConfigInputOperationOutputAlias,
                crate::output::SelectAggregateResourceConfigOutput,
                crate::error::SelectAggregateResourceConfigError,
                crate::input::SelectAggregateResourceConfigInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The SQL query SELECT command. </p>
        pub fn expression(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.expression(inp);
            self
        }
        pub fn set_expression(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_expression(input);
            self
        }
        /// <p>The name of the configuration aggregator.</p>
        pub fn configuration_aggregator_name(
            mut self,
            inp: impl Into<std::string::String>,
        ) -> Self {
            self.inner = self.inner.configuration_aggregator_name(inp);
            self
        }
        pub fn set_configuration_aggregator_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_aggregator_name(input);
            self
        }
        /// <p>The maximum number of query results returned on each page. </p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The maximum number of query results returned on each page. AWS Config also allows the Limit request parameter.</p>
        pub fn max_results(mut self, inp: i32) -> Self {
            self.inner = self.inner.max_results(inp);
            self
        }
        pub fn set_max_results(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_max_results(input);
            self
        }
        /// <p>The nextToken string returned in a previous request that you use to request the next page of results in a paginated response. </p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct SelectResourceConfig<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::select_resource_config_input::Builder,
    }
    impl<C, M, R> SelectResourceConfig<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::SelectResourceConfigOutput,
            smithy_http::result::SdkError<crate::error::SelectResourceConfigError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::SelectResourceConfigInputOperationOutputAlias,
                crate::output::SelectResourceConfigOutput,
                crate::error::SelectResourceConfigError,
                crate::input::SelectResourceConfigInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The SQL query <code>SELECT</code> command.</p>
        pub fn expression(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.expression(inp);
            self
        }
        pub fn set_expression(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_expression(input);
            self
        }
        /// <p>The maximum number of query results returned on each page. </p>
        pub fn limit(mut self, inp: i32) -> Self {
            self.inner = self.inner.limit(inp);
            self
        }
        pub fn set_limit(mut self, input: std::option::Option<i32>) -> Self {
            self.inner = self.inner.set_limit(input);
            self
        }
        /// <p>The <code>nextToken</code> string returned in a previous request that you use to request the next page of results in a paginated response. </p>
        pub fn next_token(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.next_token(inp);
            self
        }
        pub fn set_next_token(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_next_token(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct StartConfigRulesEvaluation<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::start_config_rules_evaluation_input::Builder,
    }
    impl<C, M, R> StartConfigRulesEvaluation<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::StartConfigRulesEvaluationOutput,
            smithy_http::result::SdkError<crate::error::StartConfigRulesEvaluationError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::StartConfigRulesEvaluationInputOperationOutputAlias,
                crate::output::StartConfigRulesEvaluationOutput,
                crate::error::StartConfigRulesEvaluationError,
                crate::input::StartConfigRulesEvaluationInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// Appends an item to `ConfigRuleNames`.
        ///
        /// To override the contents of this collection use [`set_config_rule_names`](Self::set_config_rule_names).
        /// <p>The list of names of AWS Config rules that you want to run
        /// evaluations for.</p>
        pub fn config_rule_names(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_names(inp);
            self
        }
        pub fn set_config_rule_names(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_names(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct StartConfigurationRecorder<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::start_configuration_recorder_input::Builder,
    }
    impl<C, M, R> StartConfigurationRecorder<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::StartConfigurationRecorderOutput,
            smithy_http::result::SdkError<crate::error::StartConfigurationRecorderError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::StartConfigurationRecorderInputOperationOutputAlias,
                crate::output::StartConfigurationRecorderOutput,
                crate::error::StartConfigurationRecorderError,
                crate::input::StartConfigurationRecorderInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the recorder object that records each configuration
        /// change made to the resources.</p>
        pub fn configuration_recorder_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.configuration_recorder_name(inp);
            self
        }
        pub fn set_configuration_recorder_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_recorder_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct StartRemediationExecution<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::start_remediation_execution_input::Builder,
    }
    impl<C, M, R> StartRemediationExecution<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::StartRemediationExecutionOutput,
            smithy_http::result::SdkError<crate::error::StartRemediationExecutionError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::StartRemediationExecutionInputOperationOutputAlias,
                crate::output::StartRemediationExecutionOutput,
                crate::error::StartRemediationExecutionError,
                crate::input::StartRemediationExecutionInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The list of names of AWS Config rules that you want to run remediation execution for.</p>
        pub fn config_rule_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.config_rule_name(inp);
            self
        }
        pub fn set_config_rule_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_config_rule_name(input);
            self
        }
        /// Appends an item to `ResourceKeys`.
        ///
        /// To override the contents of this collection use [`set_resource_keys`](Self::set_resource_keys).
        /// <p>A list of resource keys to be processed with the current request. Each element in the list consists of the resource type and resource ID. </p>
        pub fn resource_keys(mut self, inp: impl Into<crate::model::ResourceKey>) -> Self {
            self.inner = self.inner.resource_keys(inp);
            self
        }
        pub fn set_resource_keys(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ResourceKey>>,
        ) -> Self {
            self.inner = self.inner.set_resource_keys(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct StopConfigurationRecorder<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::stop_configuration_recorder_input::Builder,
    }
    impl<C, M, R> StopConfigurationRecorder<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::StopConfigurationRecorderOutput,
            smithy_http::result::SdkError<crate::error::StopConfigurationRecorderError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::StopConfigurationRecorderInputOperationOutputAlias,
                crate::output::StopConfigurationRecorderOutput,
                crate::error::StopConfigurationRecorderError,
                crate::input::StopConfigurationRecorderInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The name of the recorder object that records each configuration change made to the resources.</p>
        pub fn configuration_recorder_name(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.configuration_recorder_name(inp);
            self
        }
        pub fn set_configuration_recorder_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.inner = self.inner.set_configuration_recorder_name(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct TagResource<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::tag_resource_input::Builder,
    }
    impl<C, M, R> TagResource<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::TagResourceOutput,
            smithy_http::result::SdkError<crate::error::TagResourceError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::TagResourceInputOperationOutputAlias,
                crate::output::TagResourceOutput,
                crate::error::TagResourceError,
                crate::input::TagResourceInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The Amazon Resource Name (ARN) that identifies the resource for which to list the tags. Currently, the supported resources are <code>ConfigRule</code>, <code>ConfigurationAggregator</code> and <code>AggregatorAuthorization</code>.</p>
        pub fn resource_arn(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_arn(inp);
            self
        }
        pub fn set_resource_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_arn(input);
            self
        }
        /// Appends an item to `Tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        /// <p>An array of tag object.</p>
        pub fn tags(mut self, inp: impl Into<crate::model::Tag>) -> Self {
            self.inner = self.inner.tags(inp);
            self
        }
        pub fn set_tags(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::Tag>>,
        ) -> Self {
            self.inner = self.inner.set_tags(input);
            self
        }
    }
    #[derive(std::fmt::Debug)]
    pub struct UntagResource<
        C = smithy_client::erase::DynConnector,
        M = aws_hyper::AwsMiddleware,
        R = smithy_client::retry::Standard,
    > {
        handle: std::sync::Arc<super::Handle<C, M, R>>,
        inner: crate::input::untag_resource_input::Builder,
    }
    impl<C, M, R> UntagResource<C, M, R>
    where
        C: smithy_client::bounds::SmithyConnector,
        M: smithy_client::bounds::SmithyMiddleware<C>,
        R: smithy_client::retry::NewRequestPolicy,
    {
        pub(crate) fn new(handle: std::sync::Arc<super::Handle<C, M, R>>) -> Self {
            Self {
                handle,
                inner: Default::default(),
            }
        }
        pub async fn send(
            self,
        ) -> std::result::Result<
            crate::output::UntagResourceOutput,
            smithy_http::result::SdkError<crate::error::UntagResourceError>,
        >
        where
            R::Policy: smithy_client::bounds::SmithyRetryPolicy<
                crate::input::UntagResourceInputOperationOutputAlias,
                crate::output::UntagResourceOutput,
                crate::error::UntagResourceError,
                crate::input::UntagResourceInputOperationRetryAlias,
            >,
        {
            let input = self
                .inner
                .build()
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            let op = input
                .make_operation(&self.handle.conf)
                .map_err(|err| smithy_http::result::SdkError::ConstructionFailure(err.into()))?;
            self.handle.client.call(op).await
        }
        /// <p>The Amazon Resource Name (ARN) that identifies the resource for which to list the tags. Currently, the supported resources are <code>ConfigRule</code>, <code>ConfigurationAggregator</code> and <code>AggregatorAuthorization</code>.</p>
        pub fn resource_arn(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.resource_arn(inp);
            self
        }
        pub fn set_resource_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.inner = self.inner.set_resource_arn(input);
            self
        }
        /// Appends an item to `TagKeys`.
        ///
        /// To override the contents of this collection use [`set_tag_keys`](Self::set_tag_keys).
        /// <p>The keys of the tags to be removed.</p>
        pub fn tag_keys(mut self, inp: impl Into<std::string::String>) -> Self {
            self.inner = self.inner.tag_keys(inp);
            self
        }
        pub fn set_tag_keys(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.inner = self.inner.set_tag_keys(input);
            self
        }
    }
}
impl<C> Client<C, aws_hyper::AwsMiddleware, smithy_client::retry::Standard> {
    pub fn from_conf_conn(conf: crate::Config, conn: C) -> Self {
        let client = aws_hyper::Client::new(conn);
        Self {
            handle: std::sync::Arc::new(Handle { client, conf }),
        }
    }
}
impl
    Client<
        smithy_client::erase::DynConnector,
        aws_hyper::AwsMiddleware,
        smithy_client::retry::Standard,
    >
{
    #[cfg(any(feature = "rustls", feature = "native-tls"))]
    pub fn new(config: &aws_types::config::Config) -> Self {
        Self::from_conf(config.into())
    }

    #[cfg(any(feature = "rustls", feature = "native-tls"))]
    pub fn from_conf(conf: crate::Config) -> Self {
        let client = aws_hyper::Client::https();
        Self {
            handle: std::sync::Arc::new(Handle { client, conf }),
        }
    }
}
